Type: Package
Package: countrycode
Title: Convert Country Names and Country Codes
Version: 1.8.0
Authors@R: 
    c(person(given = "Vincent",
             family = "Arel-Bundock",
             role = c("aut", "cre"),
             email = "vincent.arel-bundock@umontreal.ca",
             comment = c(ORCID = "0000-0003-2042-7063")),
      person(given = "CJ",
             family = "Yetman",
             role = "ctb",
             email = "cj@cjyetman.com",
             comment = c(ORCID = "0000-0001-5099-9500")),
      person(given = "Nils",
             family = "Enevoldsen",
             role = "ctb",
             email = "nils@wlonk.com",
             comment = c(ORCID = "0000-0001-7195-4117")),
      person("Etienne", "Bacher",
             email = "etienne.bacher@protonmail.com",
             role = "ctb",
             comment = c(ORCID = "0000-0002-9271-5075")),
      person(given = "Samuel",
             family = "Meichtry",
             role = "ctb",
             email = "samuel.meichtry@bj.admin.ch",
             comment = c(ORCID = "0000-0003-2165-791X")))
Description: Standardize country names, convert them into one of 40
    different coding schemes, convert between coding schemes, and assign
    region descriptors.
License: GPL-3
URL: https://vincentarelbundock.github.io/countrycode/
BugReports: https://github.com/vincentarelbundock/countrycode/issues
Depends: R (>= 2.10)
Suggests: altdoc, eurostat, testthat, tibble, ISOcodes, utf8
Encoding: UTF-8
LazyData: yes
LazyLoad: yes
RoxygenNote: 7.3.3
NeedsCompilation: no
Packaged: 2026-04-15 19:35:14 UTC; vincent
Author: Vincent Arel-Bundock [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-2042-7063>),
  CJ Yetman [ctb] (ORCID: <https://orcid.org/0000-0001-5099-9500>),
  Nils Enevoldsen [ctb] (ORCID: <https://orcid.org/0000-0001-7195-4117>),
  Etienne Bacher [ctb] (ORCID: <https://orcid.org/0000-0002-9271-5075>),
  Samuel Meichtry [ctb] (ORCID: <https://orcid.org/0000-0003-2165-791X>)
Maintainer: Vincent Arel-Bundock <vincent.arel-bundock@umontreal.ca>
Repository: CRAN
Date/Publication: 2026-04-16 05:10:13 UTC
Built: R 4.5.2; ; 2026-04-17 09:02:21 UTC; unix

Type: Package
Package: countrycode
Title: Convert Country Names and Country Codes
Version: 1.9.0
Authors@R: 
    c(person(given = "Vincent",
             family = "Arel-Bundock",
             role = c("aut", "cre"),
             email = "vincent.arel-bundock@umontreal.ca",
             comment = c(ORCID = "0000-0003-2042-7063")),
      person(given = "CJ",
             family = "Yetman",
             role = "ctb",
             email = "cj@cjyetman.com",
             comment = c(ORCID = "0000-0001-5099-9500")),
      person(given = "Nils",
             family = "Enevoldsen",
             role = "ctb",
             email = "nils@wlonk.com",
             comment = c(ORCID = "0000-0001-7195-4117")),
      person("Etienne", "Bacher",
             email = "etienne.bacher@protonmail.com",
             role = "ctb",
             comment = c(ORCID = "0000-0002-9271-5075")),
      person(given = "Samuel",
             family = "Meichtry",
             role = "ctb",
             email = "samuel.meichtry@bj.admin.ch",
             comment = c(ORCID = "0000-0003-2165-791X")))
Description: Standardize country names, convert them into one of 40
    different coding schemes, convert between coding schemes, and assign
    region descriptors.
License: GPL-3
URL: https://vincentarelbundock.github.io/countrycode/
BugReports: https://github.com/vincentarelbundock/countrycode/issues
Depends: R (>= 2.10)
Suggests: pkgsite, eurostat, testthat, tibble, yaml, ISOcodes
Encoding: UTF-8
LazyData: yes
LazyLoad: yes
Config/roxygen2/version: 8.0.0
NeedsCompilation: no
Packaged: 2026-08-19 20:23:31 UTC; vincent
Author: Vincent Arel-Bundock [aut, cre] (ORCID:
    <https://orcid.org/0000-0003-2042-7063>),
  CJ Yetman [ctb] (ORCID: <https://orcid.org/0000-0001-5099-9500>),
  Nils Enevoldsen [ctb] (ORCID: <https://orcid.org/0000-0001-7195-4117>),
  Etienne Bacher [ctb] (ORCID: <https://orcid.org/0000-0002-9271-5075>),
  Samuel Meichtry [ctb] (ORCID: <https://orcid.org/0000-0003-2165-791X>)
Maintainer: Vincent Arel-Bundock <vincent.arel-bundock@umontreal.ca>
Repository: CRAN
Date/Publication: 2026-08-20 05:21:29 UTC
Built: R 4.6.1; ; 2026-08-20 08:49:13 UTC; unix

# Shared R/Python test fixtures

These YAML files define implementation-neutral behavior executed by both the
testthat and pytest suites:

- `name-variations.yaml`: canonical names mapped to accepted variations.
- `conversions.yaml`: nested `origin → destination → source: expected`
  mappings.
- `name-nonmatches.yaml`: nested `origin → destination → sources` lists.
- `countryname.yaml`: nested `destination → source: expected` mappings.

YAML supplies native integer and null types without extra schema fields.

Keep language-specific integration tests—such as R factors and tibbles or
Pandas and Polars metadata—in their native suites.

variations <- list(


  #"Åland Islands" = c(
    #"Aland Islands",
    #"aland islands",
    #"Åland Islands",
    #"åland islands"
  #),

  "Suriname" = c(
    "Dutch Guyana",
    "Dutch Guiana"
  ),
  "French Guiana" = c(
    "French Guiana",
    "French Guyana"
  ),
  "Guyana" = c(
    "British Guiana",
    "British Guyana"
  ),

  "Congo - Brazzaville" = c(
    "republic of congo",
    "republic of the congo",
    "congo, republic of the",
    "congo, republic",
    "congo, rep.",
    "congo-brazzaville",
    "french congo"
  ),

  "Congo - Kinshasa" = c(
    "democratic republic of the congo",
    "congo, democratic republic of the",
    "dem rep of the congo",
    "the democratic republic of congo",
    "congo, dem. rep.",
    "dr congo",
    "drc",
    "droc",
    "rdc",
    "congo-kinshasa",
    "congo-zaire",
    "zaire",
    "belgian congo",
    "congo free state",
    "D.R. Congo",
    "DR Congo",
    "Democratic Republic of Congo"
    # accented regexes do not work on Windows. They are not officially supported anyway
    #"republic of the congo-léopoldville",
    # "rép. démocratique du congo",
  ),


  "China" = c(
    "People's Republic of China",
    "China, People's Republic",
    "China"
  ),

  "Hong Kong SAR China" = c(
    "Hong Kong, China",
    "Hong Kong"
  ),

  "Macao SAR China" = c(
    "Macau, China",
    "Macao, China",
    "Macau",
    "Macao"
  ),

  "Taiwan" = c(
    x = "Republic of China",
    x = "Taiwan, Province of China",
    x = "Taiwan"
  ),


  "Ireland" = c(
    "Republic of Ireland",
    "Ireland"
  ),

  "Italy" = c(
    "Italian Republic"
  ),

  "Martinique" = c(
    "France, Martinique",
    "Martinique, France"
  ),

  "North Korea" = c(
    "Democratic People's Republic of Korea",
    "DPRK",
    "Korea, Dem. Rep.",
    "DPR Korea",
    "D.P.R. Korea",
    "D.P.R Korea",
    "Korea DPR",
    "Korea D.P.R.",
    "Korea, DPR",
    "Korea, D.P.R.",
    "Korea, North",
    "Korea North",
    "Korea, Democratic People's Republic",
    "Korea (the Democratic People's Republic of)",
    "North Korea"
  ),

  "North Macedonia" = c(
    "fyrom"
  ),

  "South Africa" = c(
    "South Africa",
    "South-Africa"
  ),

  "South Korea" = c(
    "Korea, Republic of",
    "Korea, Rep. of",
    "Korea, South",
    "Korea South",
    "Republic of Korea",
    "Rep. of Korea",
    "South Korea"
  ),

  "Turkey" = c(
    "Turkey",
    "Türkiye"
  ),

  "United Arab Emirates" = c(
    "emirates",
    "united arab em.",
    "uae",
    "u.a.e."
  ),

  "United Kingdom" = c(
    "u.k.",
    "United Kingdom",
    "The United Kingdom",
    "United Kingdom of Great Britain",
    "United Kingdom of Great Britain and Northern Ireland"
  ),

  "United States" = c(
    "u.s.",
    "U.S.A.",
    "United States",
    "USA"
  ),

  "United States Minor Outlying Islands (the)" = c(
    "United States Minor Outlying Islands",
    "US Minor Outlying Islands",
    "U.S. Minor Outlying Islands",
    "Minor Outlying Islands US",
    "Minor Outlying Islands U.S.",
    "Minor Outlying Islands, US",
    "Minor Outlying Islands, U.S."
  ),

  "U.S. Virgin Islands" = c(
    "United States Virgin Islands",
    "US Virgin Islands",
    "U.S. Virgin Islands",
    "Virgin Islands, US",
    "Virgin Islands, U.S.",
    "Virgin Islands, (U.S.)",
    "Virgin Islands, (US)",
    "Virgin Islands US",
    "Virgin Islands U.S.",
    "Virgin Islands (U.S.)",
    "Virgin Islands (US)"
  ),

  "Yemen" = c(
    "yemen",
    "republic of yemen"
  ),

  "Yemen Arab Republic" = c(
    'yemen arab republic',
    'north yemen',
    'yemen (sana\'a)'
  ),

  "Yemen People's Republic" = c(
    'yemen people\'s republic',
    'people\'s democratic republic of yemen',
    'south yemen',
    'democratic yemen',
    'yemen (aden)'
  )

)

#' Convert country codes or country names
#'
#' The \code{countrycode} function can convert to and from several different
#' country coding schemes.  It uses regular expressions to convert country
#' names (e.g. Sri Lanka) into any of those coding schemes, or into
#' standardized country names in several languages.  It can create variables
#' with the name of the continent and/or several regional groupings to which
#' each country belongs.
#'
#' Type ?codelist to get a list of available origin and destination
#' codes.
#'
#' @name countrycode-package
#' @aliases countrycode-package
#' @title Convert Country Codes or Country Names
#' @author Vincent Arel-Bundock \email{vincent.arel-bundock@umontreal.ca}
#' @references
#'     \url{http://arelbundock.com}
#'     \url{https://github.com/vincentarelbundock/countrycode}
#' @noRd
#' @keywords internal
"_PACKAGE"

#' Get Custom Dictionaries
#' 
#' Download a custom dictionary to use in the `custom_dict` argument of `countrycode()`
#'
#' @param dictionary A character string that specifies the dictionary to be
#' retrieved. It must be one of "global_burden_of_disease", "ch_cantons",
#' "us_states", "exiobase3", "gtap10". If NULL, the function will print the list
#' of available dictionaries. Default is NULL.
#'
#' @return If a valid dictionary is specified, the function will return that dictionary as a data.frame.
#' If an invalid dictionary or no dictionary is specified, the function will stop and throw an error message.
#'
#' @examples
#' \dontrun{
#' cd <- get_dictionary("us_states")
#' countrycode::countrycode(c("MO", "MN"), origin = "state.abb", "state.name", custom_dict = cd)
#' }
#' @export
get_dictionary <- function(dictionary = NULL) {
    valid <- sort(c("global_burden_of_disease", "ch_cantons", "us_states", "exiobase3", "gtap10"))
    if (is.null(dictionary)) {
        message(sprintf("Available dictionaries: %s", paste(valid, collapse = ", ")))
        return(invisible(NULL))
    }
    if (isTRUE(is.character(dictionary) && length(dictionary) == 1 && dictionary %in% valid)) {
        url <- sprintf("https://github.com/vincentarelbundock/countrycode/raw/main/data/custom_dictionaries/data_%s.rds", dictionary)
        tmp <- tempfile()
        utils::download.file(url, tmp)
        out <- readRDS(tmp)
        unlink(tmp)
        return(out)
    } else {
        stop("dictionary must be a character vector of length 1 and one of: ", paste(valid, collapse = ", "))
    }
}

#' List of CLDR country name codes and associated examples
#'
#' \itemize{
#'   \item Code: CLDR code
#'   \item Example: French Southern Territories in different languages
#' }
#' @docType data
#' @keywords datasets
#' @name cldr_examples
#' @usage cldr_examples
#' @format data frame
NULL

#' Guess the code/name of a vector
#'
#' Users sometimes do not know what kind of code or field their data contain.
#' This function tries to guess by comparing the similarity between a
#' user-supplied vector and all the codes included in the `countrycode`
#' dictionary.
#'
#' @param codes a vector of country codes or country names
#' @param min_similarity the function returns all field names where over than
#' `min_similarity`% of codes are shared between the supplied vector and the
#' `countrycode` dictionary.
#'
#' @export
#' @examples
#' # Guess ISO codes
#' guess_field(c('DZA', 'CAN', 'DEU'))
#'
#' # Guess country names
#' guess_field(c('Guinea','Iran','Russia','North Korea',rep('Ivory Coast',50),'Scotland'))
guess_field <- function(codes, min_similarity = 80) {
  if (!mode(codes) %in% c('character', 'numeric')) {
    stop('sourcevar must be a character or numeric vector. This error often arises when users pass a tibble (e.g., from dplyr) instead of a column vector from a data.frame (i.e., my_tbl[, 2] vs. my_df[, 2] vs. my_tbl[[2]]). This can also happen when `sourcevar` is entirely composed of `NA`, which `R` treats as entries of class logical.')
  }

  x <- unique(codes)

  match_percentage <-
    sapply(countrycode::codelist, function(code) {
      sum(x %in% code) / length(x) * 100
    })

  match_percentage <- match_percentage[match_percentage >= min_similarity]

  match_percentage <- match_percentage[order(match_percentage, decreasing = TRUE)]

  data.frame(code = names(match_percentage),
             percent_of_unique_matched = match_percentage,
             stringsAsFactors = FALSE)
}

#' Country Code Translation Data Frame (Cross-Sectional)
#'
#' A data frame used internally by the [countrycode()] function. `countrycode` can use any valid code as destination, but only some codes can be used as origin.
#'
#' ## Origin and Destination
#'
#' - `cctld`: IANA country code top-level domain
#' - `country.name.en`: country name (English)
#' - `country.name.de`: country name (German)
#' - `country.name.fr`: country name (French)
#' - `country.name.it`: country name (Italian)
#' - `country.name.es`: country name (Spanish)
#' - `cowc`: Correlates of War character
#' - `cown`: Correlates of War numeric
#' - `dhs`: Demographic and Health Surveys Program
#' - `ecb`: European Central Bank
#' - `eurostat`:  Eurostat
#' - `fao`: Food and Agriculture Organization of the United Nations numerical code
#' - `fips`: FIPS 10-4 (Federal Information Processing Standard)
#' - `gaul`: Global Administrative Unit Layers
#' - `genc2c`: GENC 2-letter code
#' - `genc3c`: GENC 3-letter code
#' - `genc3n`: GENC numeric code
#' - `gwc`: Gleditsch & Ward character
#' - `gwn`: Gleditsch & Ward numeric
#' - `imf`: International Monetary Fund (Warning: The IMF generally uses ISO codes. These codes are WEO-related, but may be inconsistently used in the wild.)
#' - `ioc`: International Olympic Committee
#' - `iso2c`: ISO-2 character
#' - `iso3c`: ISO-3 character
#' - `iso3n`: ISO-3 numeric
#' - `p5n`: Polity V numeric country code
#' - `p5c`: Polity V character country code
#' - `p4n`: Polity IV numeric country code
#' - `p4c`: Polity IV character country code
#' - `un`: United Nations M49 numeric codes
#' - `unicode.symbol`: Region subtag (often displayed as emoji flag)
#' - `unhcr`: United Nations High Commissioner for Refugees
#' - `unpd`: United Nations Procurement Division
#' - `vdem`: Varieties of Democracy (V-Dem version 8, April 2018)
#' - `wb`: World Bank (very similar but not identical to iso3c)
#' - `wvs`: World Values Survey numeric code
#'
#' ## Destination only
#'
#' - `cldr.*`: 600+ country name variants from the UNICODE CLDR project (e.g., "cldr.short.en").
#'   Inspect the [`cldr_examples`][countrycode::cldr_examples] data.frame for a full list of
#'   available country names and examples.
#' - `ar5`: IPCC's regional mapping used both in the Fifth Assessment Report
#'              (AR5) and for the Reference Concentration Pathways (RCP)
#' - `continent`: Continent as defined in the World Bank Development Indicators
#' - `cow.name`: Correlates of War country name
#' - `currency`: ISO 4217 currency name
#' - `eurocontrol_pru`:  European Organisation for the Safety of Air Navigation
#' - `eurocontrol_statfor`:  European Organisation for the Safety of Air Navigation
#' - `eu28`: Member states of the European Union (as of December 2015),
#'               without special territories
#' - `icao.region`: International Civil Aviation Organization region
#' - `iso.name.en`: ISO English short name
#' - `iso.name.fr`: ISO French short name
#' - `iso4217c`: ISO 4217 currency alphabetic code
#' - `iso4217n`: ISO 4217 currency numeric code
#' - `p4.name`: Polity IV country name
#' - `region`: 7 Regions as defined in the World Bank Development Indicators
#' - `region23`: 23 Regions as used to be in the World Bank Development Indicators (legacy)
#' - `telephone`: ITU-T E.164 country codes for telecommunication
#' - `un.name.ar`: United Nations Arabic country name
#' - `un.name.en`: United Nations English country name
#' - `un.name.es`: United Nations Spanish country name
#' - `un.name.fr`: United Nations French country name
#' - `un.name.ru`: United Nations Russian country name
#' - `un.name.zh`: United Nations Chinese country name
#' - `un.region.name`: United Nations region name
#' - `un.region.code`: United Nations region code
#' - `un.regionintermediate.name`: United Nations intermediate region name
#' - `un.regionintermediate.code`: United Nations intermediate region code
#' - `un.regionsub.name`: United Nations sub-region name
#' - `un.regionsub.code`: United Nations sub-region code
#' - `unhcr.region`: United Nations High Commissioner for Refugees region name
#' - `wvs.name`: World Values Survey numeric code country name
#'
#' @note The Correlates of War (cow) and Polity 4 (p4) project produce codes in
#' country year format. Some countries go through political transitions that
#' justify changing codes over time. When building a purely cross-sectional
#' conversion dictionary, this forces us to make arbitrary choices with respect
#' to some entities (e.g., Western Germany, Vietnam, Serbia). `countrycode`
#' includes a reconciled dataset in panel format,
#' [`codelist_panel`][countrycode::codelist_panel]. Instead of converting code, we recommend
#' that users dealing with panel data "left-merge" their data into this panel
#' dictionary.
#'
#' @docType data
#' @keywords datasets
#' @name codelist
#' @format A data frame with codes as columns.
NULL

#' A dataframe of alternative country names in many languages. Used internally by
#' the `countryname` function.
#'
#' @docType data
#' @keywords datasets
#' @name countryname_dict
#' @format dataframe
NULL

#' Country Code Translation Data Frame (Country-Year Panel)
#'
#' A panel of country-year observations with various codes
#'
#' @docType data
#' @keywords datasets
#' @name codelist_panel
#' @usage codelist_panel
#' @format data frame with codes as columns
NULL

#' Convert country names in any language to another name or code
#'
#' Converts long country names in any language to one of many different country
#' code schemes or country names. `countryname` does 2 passes on the data.
#' First, it tries to detect variations of country names in many languages
#' extracted from the Unicode Common Locale Data Repository. Second, it applies
#' `countrycode`'s English regexes to try to match the remaining cases. Because
#' it does two passes, `countryname` can sometimes produce ambiguous results,
#' e.g., Saint Martin vs. Saint Martin (French Part). Users who need a "safer"
#' option can use: `countrycode(x, "country.name", "country.name")` Note that
#' the function works with non-ASCII characters. Please see the Github page for
#' examples.
#'
#' @param sourcevar Vector which contains the codes or country names to be
#' converted (character or factor)
#' @param destination Coding scheme of destination (string such as "iso3c"
#' enclosed in quotes ""): type `?codelist` for a list of
#' available codes.
#' @param warn Prints unique elements from sourcevar for which no match was found
#' @inheritParams countrycode
#' @export
#' @aliases countryname
#' @examples
#' \dontrun{
#' x <- c('Afaganisitani', 'Barbadas', 'Sverige', 'UK')
#' countryname(x)
#' countryname(x, destination = 'iso3c')
#' }
#'
countryname <- function(sourcevar, destination = 'country.name.en', nomatch = NA, warn = TRUE) {
    
    out <- countrycode(sourcevar = sourcevar,
                       origin = 'country.name.alt',
                       destination = 'country.name.en',
                       custom_dict = countrycode::countryname_dict,
                       warn = FALSE)
    
    idx <- is.na(out)
    out[idx] <- countrycode(sourcevar = sourcevar[idx], 
                            origin = 'country.name.en', 
                            destination = 'country.name.en', 
                            nomatch = nomatch,
                            warn = warn)
    
    if (destination != 'country.name.en') {
      # Issue 309: in the second pass we can use the origin vector for NAs, but only if origin and destination are of the same type and origin is a country name, not a code.
      out <- countrycode(sourcevar = out,
                         origin = 'country.name.en', 
                         destination = destination,
                        #  custom_dict = countrycode::codelist, 
                         nomatch = nomatch,
                         warn = warn)
    }
    
    return(out)
}

context('countryname function')

test_that('reported bugs', {
  expect_identical(countryname("Federated States of Micronesia"),
                   "Micronesia (Federated States of)")
})

test_that('output types', {
    expect_identical(countryname('ジンバブエ'), 'Zimbabwe')
    expect_identical(countryname('ジンバブエ', 'country.name.de'), 'Simbabwe')
    expect_identical(countryname('ジンバブエ', 'iso3c'), 'ZWE')
    expect_identical(countryname('ジンバブエ', 'cown'), 552)
    # issue 309: irrelevant warning with numeric destination
    expect_warning(countryname('ジンバブエ', 'cown'), NA)
})

test_that('input: character ', {

    x <- c('ジンバブエ', 'Afeganistãu',  'Barbadas', 'Sverige', 'UK',
           'il-Georgia tan-Nofsinhar u l-Gżejjer Sandwich tan-Nofsinhar')
    answers <- c("Zimbabwe", "Afghanistan", "Barbados", "Sweden", "United Kingdom", 
                 "South Georgia & South Sandwich Islands")
    expect_identical(countryname(x), answers)

})

test_that('input: factor vector', {

    x <- c('ジンバブエ', 'Afeganistãu',  'Barbadas', 'Sverige', 'United Kingdom',
           'il-Georgia tan-Nofsinhar u l-Gżejjer Sandwich tan-Nofsinhar')
    x <- factor(x)

    answers <- c("Zimbabwe", "Afghanistan", "Barbados", "Sweden", "United Kingdom", 
                 "South Georgia & South Sandwich Islands")
    expect_identical(countryname(x), answers)

})

test_that('input: tibble ', {

    library(tibble)
    x <- c('ジンバブエ', 'Afeganistãu',  'Barbadas', 'Sverige', 'UK',
           'il-Georgia tan-Nofsinhar u l-Gżejjer Sandwich tan-Nofsinhar')
    x <- tibble(x)

    answers <- c("Zimbabwe", "Afghanistan", "Barbados", "Sweden", "United Kingdom", 
                 "South Georgia & South Sandwich Islands")
    expect_identical(countryname(x$x), answers)

})


test_that("issue 336", {
    a <- countrycode("antarctica", origin = "country.name", destination = "cowc", warn = FALSE)
    expect_true(is.na(a))

    a <- countryname("antarctica", destination = "cowc", warn = FALSE)
    expect_true(is.na(a))

    a <- countryname("xyz", destination = "cowc", warn = FALSE)
    expect_true(is.na(a))

    x <- c("canada", "antarctica")
    expect_identical(countryname(x), c("Canada", "Antarctica"))
    expect_identical(countryname(x, destination = "cowc", warn = FALSE), c("CAN", NA))
    expect_identical(countryname(x, destination = "cowc", warn = FALSE, nomatch = x), c("CAN", "antarctica"))
})

#' Convert Country Codes
#'
#' Converts long country names into one of many different coding schemes.
#' Translates from one scheme to another. Converts country name or coding
#' scheme to the official short English country name. Creates a new variable
#' with the name of the continent or region to which each country belongs.
#'
#' @note
#' For a complete description of available country codes and languages,
#' please see the documentation for the [`codelist`][codelist] conversion
#' dictionary.
#'
#' Panel data (i.e., country-year) can pose particular problems when
#' converting codes. For instance, some countries like Vietnam or Serbia go
#' through political transitions that justify changing codes over time. This
#' can pose problems when using codes from organizations like CoW or Polity IV,
#' which produce codes in country-year format. Instead of converting codes
#' using `countrycode()`, we recommend that users use the
#' [`codelist_panel`][codelist_panel] data.frame as a base into which they can
#' merge their other data. This data.frame includes most relevant code, and is
#' already "reconciled" to ensure that each political unit is only represented
#' by one row in any given year. From there, it is just a matter of using [merge()]
#' to combine different datasets which use different codes.
#'
#' @param sourcevar Vector which contains the codes or country names to be
#'   converted (character or factor)
#' @param origin A string which identifies the coding scheme of origin (e.g., `"iso3c"`). See
#'   [`codelist`][codelist] for a list of available codes.
#' @param destination A string or vector of strings which identify the coding
#'   scheme of destination (e.g., `"iso3c"` or `c("cowc", "iso3c")`). See
#'   [`codelist`][codelist] for a list of available codes. When users supply a
#'   vector of destination codes, they are used sequentially to fill in
#'   missing values not covered by the previous destination code in the
#'   vector.
#' @param warn Prints unique elements from sourcevar for which no match was found
#' @param nomatch When countrycode fails to find a match for the code of
#'   origin, it fills-in the destination vector with `nomatch`. The default
#'   behavior is to fill non-matching codes with `NA`. If `nomatch = NULL`,
#'   countrycode tries to use the origin vector to fill-in missing values in the
#'   destination vector. `nomatch` must be either `NULL`, of length 1, or of the same
#'   length as `sourcevar`.
#' @param custom_dict A data frame which supplies a new dictionary to
#'   replace the built-in country code dictionary. Each column
#'   contains a different code and must include no duplicates. The
#'   data frame format should resemble [`codelist`][codelist]. Users
#'   can pre-assign attributes to this custom dictionary to affect
#'   behavior (see Examples section):
#'   \itemize{
#'   \item "origin.regex" attribute: a character vector with the names
#'     of columns containing regular expressions.
#'   \item "origin.valid" attribute: a character vector with the names
#'     of columns that are accepted as valid origin codes.
#'   }
#' @param custom_match A named vector which supplies custom origin and
#'   destination matches that will supercede any matching default result. The name
#'   of each element will be used as the origin code, and the value of each
#'   element will be used as the destination code. Values supplied via
#'   `custom_match` supersede ambiguous or duplicate matches and will not
#'   trigger the corresponding ambiguity/duplicate-match warnings for those
#'   values.
#' @param origin_regex NULL or Logical: When using a custom
#'   dictionary, if TRUE then the origin codes will be matched as
#'   regex, if FALSE they will be matched exactly. When NULL,
#'   `countrycode` will behave as TRUE if the origin name is in the
#'   `custom_dictionary`'s `origin_regex` attribute, and FALSE
#'   otherwise. See examples section below.
#' @keywords countrycode
#' @export
#' @aliases countrycode
#' @examples
#' library(countrycode)
#'
#' # ISO to Correlates of War
#' countrycode(c('USA', 'DZA'), origin = 'iso3c', destination = 'cown')
#'
#' # English to ISO
#' countrycode('Albania', origin = 'country.name', destination = 'iso3c')
#'
#' # German to French
#' countrycode('Albanien', origin = 'country.name.de', destination = 'iso.name.fr')
#'
#' # Using custom_match to supercede default codes
#' countrycode(c('United States', 'Algeria'), 'country.name', 'iso3c')
#' countrycode(c('United States', 'Algeria'), 'country.name', 'iso3c',
#'             custom_match = c('Algeria' = 'ALG'))
#'
#' x <- c("canada", "antarctica")
#' countryname(x)
#' countryname(x, destination = "cowc", warn = FALSE)
#' countryname(x, destination = "cowc", warn = FALSE, nomatch = x)
#'
countrycode <- function(sourcevar, origin, destination, warn = TRUE, nomatch = NA,
                        custom_dict = NULL, custom_match = NULL, origin_regex = NULL) {

    # default dictionary
    if (is.null(custom_dict)) {
        dictionary <- countrycode::codelist
        attr(dictionary, "origin_valid") <- c(
            "cctld", "country.name", "country.name.de", "country.name.fr", "country.name.it",
            "cowc", "cown", "dhs", "ecb", "eurostat", "fao", "fips", "gaul",
            "genc2c", "genc3c", "genc3n", "gwc", "gwn", "imf", "ioc", "iso2c",
            "iso3c", "iso3n", "p5c", "p5n", "p4c", "p4n", "un", "un_m49", "unicode.symbol",
            "unhcr", "unpd", "vdem", "wb", "wb_api2c", "wb_api3c", "wvs",
            "country.name.en.regex", "country.name.de.regex", "country.name.fr.regex",
            "country.name.it.regex", "country.name.es.regex")
        attr(dictionary, "origin_regex") <- c("country.name.de.regex",
                                              "country.name.en.regex",
                                              "country.name.fr.regex",
                                              "country.name.it.regex",
                                              "country.name.es.regex")
    } else {
        dictionary <- custom_dict
    }

    # default country names (only for default dictionary)
    if (is.null(custom_dict)) {
        if (origin == 'country.name') {
            origin <- 'country.name.en'
        }
        if (origin %in% c('country.name.en', 'country.name.de', 'country.name.it', 'country.name.fr', 'country.name.es')) {
            origin <- paste0(origin, '.regex')
        }
        destination[destination == "country.name"] <- 'country.name.en'
    }

    # dictionary attributes
    if (is.null(attr(dictionary, "origin_valid"))) {
        origin_valid <- colnames(dictionary)
    } else {
        origin_valid <- attr(dictionary, "origin_valid")
    }

    if (is.null(attr(dictionary, "destination_valid"))) {
        destination_valid <- colnames(dictionary)
    } else {
        destination_valid <- attr(dictionary, "destination_valid")
    }

    if (is.null(origin_regex)) { # user can override
        if (!is.null(attr(dictionary, "origin_regex"))) {
            origin_regex <- origin %in% attr(dictionary, "origin_regex")
        } else {
            origin_regex <- FALSE
        }
    }

    # Allow tibbles as conversion dictionary
    if('tbl_df' %in% class(dictionary)){ # allow tibble
        dictionary <- as.data.frame(dictionary)
    }

    # Sanity checks
    if (missing(sourcevar)) {
        stop('sourcevar is NULL (does not exist).')
    }

    if (!mode(sourcevar) %in% c('character', 'numeric')) {
        stop('sourcevar must be a character or numeric vector. This error often arises when users pass a tibble (e.g., from dplyr) instead of a column vector from a data.frame (i.e., my_tbl[, 2] vs. my_df[, 2] vs. my_tbl[[2]]). This can also happen when `sourcevar` is entirely composed of `NA`, which `R` treats as entries of class logical.')
    }

    if (!is.null(nomatch) & (length(nomatch) != 1) & (length(nomatch) != length(sourcevar))) {
        stop('nomatch needs to be NULL, or of length 1 or ', length(sourcevar), '.')
    }

    if (!is.character(origin) ||
        length(origin) != 1 ||
        !origin %in% origin_valid) {
        stop(sprintf("The `origin` argument must be a string of length 1 equal to one of these values: %s.",
                     paste(origin_valid, collapse = ", ")))
    }

    if (!is.character(destination) ||
        !all(destination %in% destination_valid)) {
        stop("The `destination` argument must be a string or a vector of strings where each element is equal to one of the column names in the conversion directory (by default: `codelist`).")
    }

    if(!inherits(dictionary, "data.frame")) {
        stop("The `dictionary` argument must be a data frame or tibble with codes as columns.")
    }

    dups = any(duplicated(stats::na.omit(dictionary[, origin])))
    if(dups){
        stop("Countrycode cannot accept dictionaries with duplicated origin codes")
    }

    # Copy origin_vector for later re-use
    origin_vector <- sourcevar

    # Case-insensitive matching
    if(is.null(custom_dict)){ # only for built-in dictionary
        # unicode.symbol breaks uppercase on Windows R-devel 2022-02-02; rejected by CRAN
        if(inherits(origin_vector, 'character') & !grepl('country|unicode.symbol', origin)){
            # only apply toupper() on unique values and match after.
            # much faster than applying toupper() on the whole vector
            # when vector is very large
            uniques <- unique(origin_vector)
            uppercase <- toupper(uniques)
            origin_vector <- unname(uppercase[match(origin_vector, uniques)])
        }
    }

    out <- rep(NA, length(sourcevar))
    for (dest in destination) {
        if (length(destination) == 1) {
            out <- countrycode_convert(
                ## user-supplied arguments
                sourcevar = sourcevar,
                origin = origin,
                destination = dest,
                warn = warn,
                nomatch = nomatch,
                custom_dict = custom_dict,
                custom_match = custom_match,
                origin_regex = origin_regex,
                ## countrycode-supplied arguments
                origin_vector = origin_vector,
                dictionary = dictionary)
        } else {
            out <- ifelse(is.na(out),
                          countrycode_convert(
                              ## user-supplied arguments
                              sourcevar = sourcevar,
                              origin = origin,
                              destination = dest,
                              warn = warn,
                              nomatch = nomatch,
                              custom_dict = custom_dict,
                              custom_match = custom_match,
                              origin_regex = origin_regex,
                              ## countrycode-supplied arguments
                              origin_vector = origin_vector,
                              dictionary = dictionary),
                          out)
        }
    }
    return(out)
}


#' internal function called by `countrycode()`
#'
#' @keywords internal
#' @noRd
countrycode_convert <- function(# user-supplied arguments
                                sourcevar,
                                origin,
                                destination,
                                warn,
                                nomatch,
                                custom_dict,
                                custom_match,
                                origin_regex,
                                # countrycode-supplied arguments
                                origin_vector,
                                dictionary
                                ) {


    # Convert
    if (origin_regex) { # regex codes
        dict <- stats::na.omit(dictionary[, c(origin, destination)])
        sourcefctr <- factor(origin_vector)

        # possibilities (add NA so there's at least one item)
        choices <- c(levels(sourcefctr), NA)
        # sometimes an error is triggered by encoding issues
        choices <- tryCatch(trimws(choices), error = function(e) choices)

        # Apply all regexes on all inputs. This gives a matrix where rows
        # are the inputs and columns are the regexes.
        # For each row, the `TRUE` values indicate the matches.
        matchidx <- sapply(dict[[origin]], grepl, x = choices,
                           perl = TRUE, ignore.case = TRUE)
        if (all(is.na(choices))) {
            matches <- vector("list", length = length(choices))
        } else {
            # Issue reported to Vincent by email
            # simplify=FALSE was introduced in R 4.1.0. we want coverage before
            # out <- try(apply(matchidx, 1, which, simplify = FALSE))
            out <- apply(matchidx, 1, which)
            if (length(out) == 0) {
                out <- rep(list(NULL), nrow(matchidx))
            }
            names(out) <- choices
            matches <- lapply(out, function(x) dict[x, destination])
        }


        # fill elements that have zero matches with the appropriate NA
        matches[sapply(matches, length) == 0] <- `class<-`(NA, class(dict[[destination]]))

        # create destination_list with elements that have more than one match
        destination_list <- matches[sapply(matches, length) > 1]

        # add origin_vector value to beginning of match results to replicate previous behavior
        destination_list <- Map(c, names(destination_list), destination_list)

        # set elements with multiple matches to the appropriate NA
        matches[sapply(matches, length) > 1] <- `class<-`(NA, class(dict[[destination]]))

        # remove all but last match to replicate previous behavior
        matches <- sapply(matches, function(x) { x[length(x)] })

        # replace with custom matches if set
        if (!is.null(custom_match)) {
          matchidxs <- match(names(matches), names(custom_match))
          cust_matched <- !is.na(matchidxs)
          matches[cust_matched] <- custom_match[matchidxs][cust_matched]
        }

        # apply new levels to sourcefctr and unname
        destination_vector <- unname(matches[as.numeric(sourcefctr)])

    } else { # non-regex codes

        # sanity check
        if (is.character(origin_vector) && is.numeric(dictionary[[origin]])) {
            msg <- sprintf("To convert a `%s` code, `sourcevar` must be numeric.", origin)
            stop(msg, call. = FALSE)
        }

        dict <- stats::na.omit(dictionary[, c(origin, destination)])

        sourcefctr <- factor(origin_vector)

        # match levels of sourcefctr
        if (identical(origin, "cctld")) {
          matchidxs <- match(levels(sourcefctr), toupper(dict[[origin]]))
        } else {
          matchidxs <- match(levels(sourcefctr), dict[[origin]])
        }
        matches <- dict[[destination]][matchidxs]

        # replace with custom matches if set
        if (!is.null(custom_match)) {
          matchidxs <- match(levels(sourcefctr), names(custom_match))
          cust_matched <- !is.na(matchidxs)
          matches[cust_matched] <- custom_match[matchidxs][cust_matched]
        }

        # apply new levels to sourcefctr
        destination_vector <- matches[as.numeric(sourcefctr)]
    }

    # Filling-in failed matches
    sane_sourcevar <- class(sourcevar)[1] == class(destination_vector)[1]
    sane_nomatch <- class(nomatch)[1] == class(destination_vector)[1]
    idx <- is.na(destination_vector)
    if (is.null(nomatch)) {
        if (sane_sourcevar) {
            destination_vector[idx] <- sourcevar[idx]
        } else if (class(sourcevar)[1] == "factor" & class(destination_vector)[1] == "character") {
            destination_vector[idx] <- as.character(sourcevar[idx])
        } else {
            warning("The origin and destination codes are not of the same
                    class. Filling-in bad matches with NA instead.", call. = FALSE)
        }
    } else if ((length(nomatch) == 1) && is.na(nomatch)) { # NA
    } else if ((length(nomatch) == 1) && sane_nomatch) { # single replacement
        destination_vector[idx] <- nomatch
    } else if ((length(nomatch) == length(sourcevar)) & sane_sourcevar) { # vector replacement
        destination_vector[idx] <- nomatch[idx]
    } else {
        warning("The argument `nomatch` must be NULL, NA, or of the same class
                as the destination vector. Filling-in bad matches with NA instead.", call. = FALSE)
    }

    # Warnings
    if(warn){
        badmatch <- sort(unique(origin_vector[is.na(destination_vector)]))
        badmatch <- badmatch[!badmatch %in% names(custom_match)]  # do not report <NA>'s that were set explicitly by custom_match
        if(length(badmatch) > 0){
            warning("Some values were not matched unambiguously: ", paste(badmatch, collapse=", "),
                    "\nTo fix unmatched values, please use the `custom_match` argument. ",
                    "If you think the default matching rules should be improved, please file an issue at ",
                    "https://github.com/vincentarelbundock/countrycode/issues\n", call. = FALSE)
        }
        if(origin_regex){
           if(length(destination_list) > 0){
               if (!is.null(custom_match)) {
                   destination_list <- destination_list[!names(destination_list) %in% names(custom_match)]
               }
               if (length(destination_list) > 0) {
                   destination_list <- lapply(destination_list, function(k) paste(k, collapse=','))
                   destination_list <- sort(unique(do.call('c', destination_list)))
                   warning("Some strings were matched more than once, and therefore set to <NA> in the result: ", paste(destination_list, collapse="; "), "\n", call. = FALSE)
               }
           }
        }
    }
    return(destination_vector)
}

context('Corner cases')


test_that("Issue #258", {
    expect_equal(
        codelist_panel[codelist_panel$country.name.en == "Germany" & codelist_panel$year == 1900,]$gwn,
        255,
        ignore_attr = TRUE)
    expect_equal(
        codelist_panel[grepl("Korea", codelist_panel$country.name.en) & codelist_panel$year == 1900,]$gwn,
        730)
})

test_that("Issue #320: GW historical polities are present with expected ranges", {
    cs <- countrycode::codelist
    pan <- countrycode::codelist_panel

    expected <- data.frame(
        gwn = c(89, 563, 564, 711, 815),
        gwc = c("UPC", "TRA", "OFS", "TBT", "VNM"),
        start = c(1823, 1852, 1854, 1913, 1816),
        end = c(1839, 1910, 1910, 1950, 1893),
        stringsAsFactors = FALSE
    )

    for (i in seq_len(nrow(expected))) {
        rec <- expected[i, ]

        idx_pan <- which(pan$gwc == rec$gwc & pan$gwn == rec$gwn)
        pan_i <- pan[idx_pan, , drop = FALSE]
        expect_gt(nrow(pan_i), 0)
        if (nrow(pan_i) == 0) next
        expect_equal(min(pan_i$year), rec$start)
        expect_equal(max(pan_i$year), rec$end)

        idx_cs <- which(cs$gwc == rec$gwc & cs$gwn == rec$gwn)
        cs_i <- cs[idx_cs, , drop = FALSE]
        expect_equal(nrow(cs_i), 1)
    }
})

test_that("Issue #320: GW historical code conversion", {
    expect_equal(89, countrycode("UPC", "gwc", "gwn"))
    expect_equal(563, countrycode("TRA", "gwc", "gwn"))
    expect_equal(564, countrycode("OFS", "gwc", "gwn"))
    expect_equal(711, countrycode("TBT", "gwc", "gwn"))
    expect_equal(815, countrycode("VNM", "gwc", "gwn"))
    expect_equal(817, countrycode("RVN", "gwc", "gwn"))

    expect_equal("UPC", countrycode(89, "gwn", "gwc"))
    expect_equal("TRA", countrycode(563, "gwn", "gwc"))
    expect_equal("OFS", countrycode(564, "gwn", "gwc"))
    expect_equal("TBT", countrycode(711, "gwn", "gwc"))
    expect_equal("VNM", countrycode(815, "gwn", "gwc"))
    expect_equal("RVN", countrycode(817, "gwn", "gwc"))
})


test_that("UN spanish name is Trinidad y Tabago: Issue #299", {
    expect_equal(countrycode("Trinidad and Tobago", "country.name", "un.name.es"), "Trinidad y Tabago")
})


test_that("Issue #244", {
    expect_equal(countrycode('.de', 'cctld', 'country.name'), "Germany")
})


test_that('Namibia iso2c is not converted to NA', {
    expect_equal('NA', countrycode("Namibia", 'country.name', 'iso2c'))
    expect_equal('NA', countrycode("Namibia", 'country.name', 'genc2c'))
    expect_equal('NA', countrycode("Namibia", 'country.name', 'eurostat'))
    expect_equal('NA', countrycode("Namibia", 'country.name', 'wb_api2c'))
    expect_equal('NA', countrycode("Namibia", 'country.name', 'ecb'))
})

test_that("Viet Nam variations", {
  expect_equal("RVN", countrycode("Republic of Viet Nam", "country.name", "cowc"))
  expect_equal("RVN", countrycode("Republic of VietNam", "country.name", "cowc"))
  expect_equal("RVN", countrycode("South VietNam", "country.name", "cowc"))
  expect_equal("DRV", countrycode("Democratic Republic of VietNam", "country.name", "cowc"))
  expect_equal("DRV", countrycode("Democratic Republic of Viet Nam", "country.name", "cowc"))
  expect_equal("DRV", countrycode("North Viet Nam", "country.name", "cowc"))

  expect_equal(35, countrycode("Republic of VietNam", "country.name", "vdem"))
  expect_equal(34, countrycode("Democratic Republic of Viet Nam", "country.name", "vdem"))
  expect_equal(34, countrycode("VietNam", "country.name", "vdem"))
})

test_that("bangladesh", {
    expect_equal(
        countrycode("Bangladesh", "country.name.de", "iso3c"),
        "BGD")
    expect_equal(
        countrycode("Bangladesch", "country.name.de", "iso3c"),
        "BGD")
})

test_that("netherlands", {
    expect_equal(
        countrycode("Holland", "country.name", "country.name"),
        "Netherlands")
    expect_equal(
        countrycode("Hollande", "country.name.fr", "country.name"),
        "Netherlands")
    expect_equal(
        countrycode("Niederländische Antillen", "country.name.de", "country.name.en"),
        "Netherlands Antilles")
    expect_equal(
        countrycode("Karibische Niederlande", "country.name.de", "country.name.en"),
        "Caribbean Netherlands")
    expect_equal(
        countrycode("Caraibi olandesi", "country.name.it", "country.name.en"),
        "Caribbean Netherlands")
    expect_equal(
      countrycode("Caribe holandes", "country.name.es", "country.name.en"),
      "Netherlands Antilles")
})


test_that("macedonia", {
    expect_equal(
        countrycode("Macédoine du Nord", "country.name.fr", "country.name.en"),
        "North Macedonia")
    expect_equal(
        countrycode("FYROM", "country.name.fr", "country.name.en"),
        "North Macedonia")
})



test_that("misc", {
    expect_equal(
        countrycode("Sint Maarten", "country.name.de", "iso3c"),
        "SXM")
    expect_equal(
        countrycode("Aruba", "country.name.de", "iso3c"),
        "ABW")
    expect_equal(
        countrycode("Curaçao", "country.name.de", "iso3c"),
        "CUW")
})


# Issue #364: custom_match should suppress duplicate-match warnings
test_that("custom_match suppresses duplicate-match warning (AC1)", {
    expect_no_warning(
        countrycode(
            c("china_hong_kong_sar", "china_macao_sar"),
            "country.name", "iso3c",
            custom_match = c(
                "china_hong_kong_sar" = "HKG",
                "china_macao_sar" = "MAC"
            )
        )
    )
})

test_that("custom_match returns correct values for HK/Macau (AC1)", {
    expect_equal(
        suppressWarnings(countrycode(
            c("china_hong_kong_sar", "china_macao_sar"),
            "country.name", "iso3c",
            custom_match = c(
                "china_hong_kong_sar" = "HKG",
                "china_macao_sar" = "MAC"
            )
        )),
        c("HKG", "MAC")
    )
})

test_that("without custom_match HK/Macau still warn (AC2)", {
    expect_warning(
        countrycode(c("china_hong_kong_sar", "china_macao_sar"), "country.name", "iso3c"),
        "matched more than once"
    )
})

test_that("partial custom_match warns only for non-overridden value (AC3)", {
    w <- tryCatch(
        countrycode(
            c("china_hong_kong_sar", "china_macao_sar"),
            "country.name", "iso3c",
            custom_match = c("china_hong_kong_sar" = "HKG")
        ),
        warning = function(w) w
    )
    expect_match(conditionMessage(w), "china_macao_sar")
    expect_false(grepl("china_hong_kong_sar", conditionMessage(w)))
})

test_that("non-ambiguous custom_match produces no warnings (AC4)", {
    expect_no_warning(
        countrycode(
            c("republic_of_korea", "isle_of_man"),
            "country.name", "iso3c",
            custom_match = c(
                "republic_of_korea" = "KOR",
                "isle_of_man" = "IMN"
            )
        )
    )
})


test_that("Turkey regex matches dotted capital \u0130 spelling", {
    x <- c("Turkey", "Turkiye", "T\u00fcrkiye", "T\u00dcRK\u0130YE")
    out <- countrycode(x, "country.name", "country.name", warn = FALSE)
    expect_equal(out, rep("Turkey", length(x)))
})

context('Usage of a custom dictionary')

test_that('custom dictionary without regex', {
    test_func <- function(iso3c_codes) countrycode(iso3c_codes, 'iso3c', 'country.name.en', custom_dict = codelist, warn = FALSE)
    expect_equal(test_func('CAN'), 'Canada')
    expect_equal(test_func(c('USA', 'CAN')), c('United States', 'Canada'))
    expect_equal(test_func(c('USA', 'CAN', 'XXX')), c('United States', 'Canada', NA))
})

test_that('custom dictionary with regex', {
    test_func <- function(countrynames) countrycode(countrynames, 'country.name.en.regex', 'iso3c', custom_dict = codelist, origin_regex = TRUE, warn = FALSE)
    expect_equal(test_func('West Germany'), 'DEU')
    expect_equal(test_func(c('U.S.A.', 'West Germany')), c('USA', 'DEU'))
    expect_equal(test_func(c('U.S.A.', 'West Germany', 'XXX')), c('USA', 'DEU', NA))
})

test_that('canadian provinces test', {
    dict <- data.frame('regex' = c('qu.bec', 'alberta', 'british.columbia'),
                       'abbreviation' = c('QC', 'AB', 'BC'),
                       'province' = c('Quebec', 'Alberta', 'British Columbia'),
                       stringsAsFactors = FALSE)
    expect_equal(countrycode('Québec', 'regex', 'abbreviation', custom_dict = dict, origin_regex = TRUE), 'QC')
    expect_equal(countrycode(c('Alberta', 'British Columbia'), 'regex', 'abbreviation', custom_dict = dict, origin_regex = TRUE), c('AB', 'BC'))
    expect_equal(countrycode('QC', 'abbreviation', 'province', custom_dict = dict), 'Quebec')
})

#context('Use of regexes in sentences')

#f = function(k) gsub('COUNTRY', k, 'The governement of COUNTRY was reelected.')
#origin = countrycode::codelist
## Only test country names with valid regex
#origin = origin[!is.na(origin$country.name.en.regex), 'country.name.en']
#sentence = sapply(origin, f)
#target = countrycode(sentence, 'country.name', 'country.name')
#problems = origin[is.na(target)]

#test_that('countrycode can catch countries in the middle of a sentence', {
    #expect_equal(length(problems), 0)
#})

#test_that('sentence with two matches returns NA and produces a warning',{
    #expect_equal(countrycode('report from Canada and the United States.', 'country.name', 'country.name', warn=FALSE), NA_character_)
    #expect_warning(countrycode('report from Canada and the United States.', 'country.name', 'country.name'))
#})

#test_that('sentence with a single match',{
    #expect_equal(countrycode('report from Canada.', 'country.name', 'country.name'), 'Canada')
#})

#test_that('known issues with previous versions of countrycode',{
    ## http://stackoverflow.com/questions/42235490/from-string-to-regex-to-new-string
    #expect_equal(countrycode('Stuff happens in North Korea', 'country.name', 'iso3c'), 'PRK')
    #expect_equal(countrycode('I heard that Ireland is beautiful.', 'country.name', 'iso3c'), 'IRL')
    #expect_equal(countrycode('   Ireland    ', 'country.name', 'iso3c'), 'IRL')
#})

context('Internal validity of regex')

iso3c_of <- function(name) countrycode(name, 'country.name', 'iso3c')

test_that('all country names with iso3c codes are matched exactly once', {
    name <- subset(codelist, !is.na(iso3c))$country.name.en
    iso3c_from_name <- countrycode(name, 'country.name', 'iso3c', warn = TRUE)
    expect_warning(iso3c_from_name, NA)
})

test_that('iso3c-to-country.name-to-iso3c is internally consistent', {
    for(iso3c_original in codelist$iso3c){
        if(!is.na(iso3c_original)){
            name <- countrycode(iso3c_original, 'iso3c', 'country.name')
            iso3c_result <- countrycode(name, 'country.name', 'iso3c')
            expect_equal(iso3c_result, iso3c_original)
        }
    }
})

regex_langs <- c("de", "en", "es", "fr", "it")
un_langs <- c("ar", "en", "es", "fr", "ru", "zh")

for (lang in regex_langs) {
  origin <- paste0("country.name.", lang)

  # All cldr columns (name, short, variant) for this language including xx_yy
  cldr_pattern <- paste0("^cldr\\.(name|short|variant)\\.", lang, "($|_)")
  cldr_cols <- grep(cldr_pattern, names(codelist), value = TRUE)

  for (col in cldr_cols) {
    test_that(paste(lang, "regex vs.", col), {
      result <- countrycode(codelist[[col]], origin, col)
      expect_equal(result, codelist[[col]])
    })
  }

  # UN names only for UN languages
  if (lang %in% un_langs) {
    un_col <- paste0("un.name.", lang)
    test_that(paste(lang, "regex vs.", un_col), {
      result <- countrycode(codelist[[un_col]], origin, un_col)
      expect_equal(result, codelist[[un_col]])
    })
  }
}

context('Emoji flags')

test_that('converting to and from emoji works', {
    expect_equal(countrycode('Antarctica','country.name','unicode.symbol'), '🇦🇶')
    expect_equal(countrycode('🇦🇶','unicode.symbol','country.name'), 'Antarctica')
})

test_that('unicode.symbol-to-country.name-to-unicode.symbol is internally consistent', {
    for(unicode.symbol.original in codelist$unicode.symbol){
        if(!is.na(unicode.symbol.original)){
            name <- countrycode(unicode.symbol.original, 'unicode.symbol', 'country.name')
            unicode.symbol.result <- countrycode(name, 'country.name', 'unicode.symbol')
            expect_equal(unicode.symbol.result, unicode.symbol.original)
        }
    }
})

context('External validity of regex')

iso3c_of <- function(name) countrycode(name, 'country.name', 'iso3c', warn = TRUE)

test_that('a variety of country names yield correct iso3c codes', {
    expect_equal(iso3c_of('Aruba'), 'ABW')
    expect_equal(iso3c_of('Afghanistan'), 'AFG')
    expect_equal(iso3c_of('Angola'), 'AGO')
    expect_equal(iso3c_of('Anguilla'), 'AIA')
    expect_equal(iso3c_of('åland Islands'), 'ALA')
    expect_equal(iso3c_of('Albania'), 'ALB')
    expect_equal(iso3c_of('Andorra'), 'AND')
    expect_equal(iso3c_of('United Arab Emirates'), 'ARE')
    expect_equal(iso3c_of('Argentina'), 'ARG')
    expect_equal(iso3c_of('Armenia'), 'ARM')
    expect_equal(iso3c_of('American Samoa'), 'ASM')
    expect_equal(iso3c_of('Antarctica'), 'ATA')
    expect_equal(iso3c_of('French Southern and Antarctic Lands'), 'ATF')
    expect_equal(iso3c_of('Antigua and Barbuda'), 'ATG')
    expect_equal(iso3c_of('Australia'), 'AUS')
    expect_equal(iso3c_of('Austria'), 'AUT')
    expect_equal(iso3c_of('Azerbaijan'), 'AZE')
    expect_equal(iso3c_of('Burundi'), 'BDI')
    expect_equal(iso3c_of('Belgium'), 'BEL')
    expect_equal(iso3c_of('Benin'), 'BEN')
    expect_equal(iso3c_of('Caribbean Netherlands'), 'BES')
    expect_equal(iso3c_of('Burkina Faso'), 'BFA')
    expect_equal(iso3c_of('Bangladesh'), 'BGD')
    expect_equal(iso3c_of('Bulgaria'), 'BGR')
    expect_equal(iso3c_of('Bahrain'), 'BHR')
    expect_equal(iso3c_of('The Bahamas'), 'BHS')
    expect_equal(iso3c_of('Bosnia and Herzegovina'), 'BIH')
    expect_equal(iso3c_of('Saint Barth\u00E9lemy'), 'BLM')
    expect_equal(iso3c_of('Belarus'), 'BLR')
    expect_equal(iso3c_of('Belize'), 'BLZ')
    expect_equal(iso3c_of('Bermuda'), 'BMU')
    expect_equal(iso3c_of('Bolivia'), 'BOL')
    expect_equal(iso3c_of('Brazil'), 'BRA')
    expect_equal(iso3c_of('Barbados'), 'BRB')
    expect_equal(iso3c_of('Brunei'), 'BRN')
    expect_equal(iso3c_of('Bhutan'), 'BTN')
    expect_equal(iso3c_of('Bouvet Island'), 'BVT')
    expect_equal(iso3c_of('Botswana'), 'BWA')
    expect_equal(iso3c_of('Central African Republic'), 'CAF')
    expect_equal(iso3c_of('Canada'), 'CAN')
    expect_equal(iso3c_of('Cocos (Keeling) Islands'), 'CCK')
    expect_equal(iso3c_of('Switzerland'), 'CHE')
    expect_equal(iso3c_of('Chile'), 'CHL')
    expect_equal(iso3c_of('China'), 'CHN')
    expect_equal(iso3c_of('C\u00F4te d\'Ivoire'), 'CIV')
    expect_equal(iso3c_of('Cameroon'), 'CMR')
    expect_equal(iso3c_of('Democratic Republic of the Congo'), 'COD')
    expect_equal(iso3c_of('Republic of the Congo'), 'COG')
    expect_equal(iso3c_of('Cook Islands'), 'COK')
    expect_equal(iso3c_of('Colombia'), 'COL')
    expect_equal(iso3c_of('Comoros'), 'COM')
    expect_equal(iso3c_of('Cabo Verde'), 'CPV')
    expect_equal(iso3c_of('Costa Rica'), 'CRI')
    expect_equal(iso3c_of('Cuba'), 'CUB')
    expect_equal(iso3c_of('Cura\u00E7ao'), 'CUW')
    expect_equal(iso3c_of('Christmas Island'), 'CXR')
    expect_equal(iso3c_of('Cayman Islands'), 'CYM')
    expect_equal(iso3c_of('Cyprus'), 'CYP')
    expect_equal(iso3c_of('Czech Republic'), 'CZE')
    expect_equal(iso3c_of('Germany'), 'DEU')
    expect_equal(iso3c_of('Djibouti'), 'DJI')
    expect_equal(iso3c_of('Dominica'), 'DMA')
    expect_equal(iso3c_of('Denmark'), 'DNK')
    expect_equal(iso3c_of('Dominican Republic'), 'DOM')
    expect_equal(iso3c_of('Algeria'), 'DZA')
    expect_equal(iso3c_of('Ecuador'), 'ECU')
    expect_equal(iso3c_of('Egypt'), 'EGY')
    expect_equal(iso3c_of('Eritrea'), 'ERI')
    expect_equal(iso3c_of('Western Sahara'), 'ESH')
    expect_equal(iso3c_of('Spain'), 'ESP')
    expect_equal(iso3c_of('Estonia'), 'EST')
    expect_equal(iso3c_of('Ethiopia'), 'ETH')
    expect_equal(iso3c_of('Finland'), 'FIN')
    expect_equal(iso3c_of('Fiji'), 'FJI')
    expect_equal(iso3c_of('Falkland Islands'), 'FLK')
    expect_equal(iso3c_of('France'), 'FRA')
    expect_equal(iso3c_of('Faroe Islands'), 'FRO')
    expect_equal(iso3c_of('Federated States of Micronesia'), 'FSM')
    expect_equal(iso3c_of('Gabon'), 'GAB')
    expect_equal(iso3c_of('United Kingdom'), 'GBR')
    expect_equal(iso3c_of('Georgia'), 'GEO')
    expect_equal(iso3c_of('Guernsey'), 'GGY')
    expect_equal(iso3c_of('Ghana'), 'GHA')
    expect_equal(iso3c_of('Gibraltar'), 'GIB')
    expect_equal(iso3c_of('Guinea'), 'GIN')
    expect_equal(iso3c_of('Guadeloupe'), 'GLP')
    expect_equal(iso3c_of('The Gambia'), 'GMB')
    expect_equal(iso3c_of('Guinea-Bissau'), 'GNB')
    expect_equal(iso3c_of('Equatorial Guinea'), 'GNQ')
    expect_equal(iso3c_of('Greece'), 'GRC')
    expect_equal(iso3c_of('Grenada'), 'GRD')
    expect_equal(iso3c_of('Greenland'), 'GRL')
    expect_equal(iso3c_of('Guatemala'), 'GTM')
    expect_equal(iso3c_of('French Guiana'), 'GUF')
    expect_equal(iso3c_of('Guam'), 'GUM')
    expect_equal(iso3c_of('Guyana'), 'GUY')
    expect_equal(iso3c_of('Hong Kong'), 'HKG')
    expect_equal(iso3c_of('Heard Island and McDonald Islands'), 'HMD')
    expect_equal(iso3c_of('Honduras'), 'HND')
    expect_equal(iso3c_of('Croatia'), 'HRV')
    expect_equal(iso3c_of('Haiti'), 'HTI')
    expect_equal(iso3c_of('Hungary'), 'HUN')
    expect_equal(iso3c_of('Indonesia'), 'IDN')
    expect_equal(iso3c_of('Isle of Man'), 'IMN')
    expect_equal(iso3c_of('India'), 'IND')
    expect_equal(iso3c_of('British Indian Ocean Territory'), 'IOT')
    expect_equal(iso3c_of('Republic of Ireland'), 'IRL')
    expect_equal(iso3c_of('Iran'), 'IRN')
    expect_equal(iso3c_of('Iraq'), 'IRQ')
    expect_equal(iso3c_of('Iceland'), 'ISL')
    expect_equal(iso3c_of('Israel'), 'ISR')
    expect_equal(iso3c_of('Italy'), 'ITA')
    expect_equal(iso3c_of('Jamaica'), 'JAM')
    expect_equal(iso3c_of('Jersey'), 'JEY')
    expect_equal(iso3c_of('Jordan'), 'JOR')
    expect_equal(iso3c_of('Japan'), 'JPN')
    expect_equal(iso3c_of('Kazakhstan'), 'KAZ')
    expect_equal(iso3c_of('Kenya'), 'KEN')
    expect_equal(iso3c_of('Kyrgyzstan'), 'KGZ')
    expect_equal(iso3c_of('Cambodia'), 'KHM')
    expect_equal(iso3c_of('Kiribati'), 'KIR')
    expect_equal(iso3c_of('Saint Kitts and Nevis'), 'KNA')
    expect_equal(iso3c_of('South Korea'), 'KOR')
    expect_equal(iso3c_of('Kuwait'), 'KWT')
    expect_equal(iso3c_of('Laos'), 'LAO')
    expect_equal(iso3c_of('Lebanon'), 'LBN')
    expect_equal(iso3c_of('Liberia'), 'LBR')
    expect_equal(iso3c_of('Libya'), 'LBY')
    expect_equal(iso3c_of('Saint Lucia'), 'LCA')
    expect_equal(iso3c_of('Liechtenstein'), 'LIE')
    expect_equal(iso3c_of('Sri Lanka'), 'LKA')
    expect_equal(iso3c_of('Lesotho'), 'LSO')
    expect_equal(iso3c_of('Lithuania'), 'LTU')
    expect_equal(iso3c_of('Luxembourg'), 'LUX')
    expect_equal(iso3c_of('Latvia'), 'LVA')
    expect_equal(iso3c_of('Macau'), 'MAC')
    expect_equal(iso3c_of('Collectivity of Saint Martin'), 'MAF')
    expect_equal(iso3c_of('Morocco'), 'MAR')
    expect_equal(iso3c_of('Monaco'), 'MCO')
    expect_equal(iso3c_of('Moldova'), 'MDA')
    expect_equal(iso3c_of('Madagascar'), 'MDG')
    expect_equal(iso3c_of('Maldives'), 'MDV')
    expect_equal(iso3c_of('Mexico'), 'MEX')
    expect_equal(iso3c_of('Marshall Islands'), 'MHL')
    expect_equal(iso3c_of('Republic of Macedonia'), 'MKD')
    expect_equal(iso3c_of('Mali'), 'MLI')
    expect_equal(iso3c_of('Malta'), 'MLT')
    expect_equal(iso3c_of('Myanmar'), 'MMR')
    expect_equal(iso3c_of('Montenegro'), 'MNE')
    expect_equal(iso3c_of('Mongolia'), 'MNG')
    expect_equal(iso3c_of('Northern Mariana Islands'), 'MNP')
    expect_equal(iso3c_of('Mozambique'), 'MOZ')
    expect_equal(iso3c_of('Mauritania'), 'MRT')
    expect_equal(iso3c_of('Montserrat'), 'MSR')
    expect_equal(iso3c_of('Martinique'), 'MTQ')
    expect_equal(iso3c_of('Mauritius'), 'MUS')
    expect_equal(iso3c_of('Malawi'), 'MWI')
    expect_equal(iso3c_of('Malaysia'), 'MYS')
    expect_equal(iso3c_of('Mayotte'), 'MYT')
    expect_equal(iso3c_of('Namibia'), 'NAM')
    expect_equal(iso3c_of('New Caledonia'), 'NCL')
    expect_equal(iso3c_of('Niger'), 'NER')
    expect_equal(iso3c_of('Norfolk Island'), 'NFK')
    expect_equal(iso3c_of('Nigeria'), 'NGA')
    expect_equal(iso3c_of('Nicaragua'), 'NIC')
    expect_equal(iso3c_of('Niue'), 'NIU')
    expect_equal(iso3c_of('Netherlands'), 'NLD')
    expect_equal(iso3c_of('Norway'), 'NOR')
    expect_equal(iso3c_of('Nepal'), 'NPL')
    expect_equal(iso3c_of('Nauru'), 'NRU')
    expect_equal(iso3c_of('New Zealand'), 'NZL')
    expect_equal(iso3c_of('Oman'), 'OMN')
    expect_equal(iso3c_of('Pakistan'), 'PAK')
    expect_equal(iso3c_of('Panama'), 'PAN')
    expect_equal(iso3c_of('Pitcairn Islands'), 'PCN')
    expect_equal(iso3c_of('Peru'), 'PER')
    expect_equal(iso3c_of('Philippines'), 'PHL')
    expect_equal(iso3c_of('Palau'), 'PLW')
    expect_equal(iso3c_of('Papua New Guinea'), 'PNG')
    expect_equal(iso3c_of('Poland'), 'POL')
    expect_equal(iso3c_of('Puerto Rico'), 'PRI')
    expect_equal(iso3c_of('North Korea'), 'PRK')
    expect_equal(iso3c_of('Portugal'), 'PRT')
    expect_equal(iso3c_of('Paraguay'), 'PRY')
    expect_equal(iso3c_of('State of Palestine'), 'PSE')
    expect_equal(iso3c_of('French Polynesia'), 'PYF')
    expect_equal(iso3c_of('Qatar'), 'QAT')
    expect_equal(iso3c_of('R\u00E9union'), 'REU')
    expect_equal(iso3c_of('Romania'), 'ROU')
    expect_equal(iso3c_of('Russia'), 'RUS')
    expect_equal(iso3c_of('Rwanda'), 'RWA')
    expect_equal(iso3c_of('Saudi Arabia'), 'SAU')
    expect_equal(iso3c_of('Sudan'), 'SDN')
    expect_equal(iso3c_of('Senegal'), 'SEN')
    expect_equal(iso3c_of('Singapore'), 'SGP')
    expect_equal(iso3c_of('South Georgia and the South Sandwich Islands'), 'SGS')
    expect_equal(iso3c_of('Saint Helena, Ascension and Tristan da Cunha'), 'SHN')
    expect_equal(iso3c_of('Svalbard and Jan Mayen'), 'SJM')
    expect_equal(iso3c_of('Solomon Islands'), 'SLB')
    expect_equal(iso3c_of('Sierra Leone'), 'SLE')
    expect_equal(iso3c_of('El Salvador'), 'SLV')
    expect_equal(iso3c_of('San Marino'), 'SMR')
    expect_equal(iso3c_of('Somalia'), 'SOM')
    expect_equal(iso3c_of('Saint Pierre and Miquelon'), 'SPM')
    expect_equal(iso3c_of('Serbia'), 'SRB')
    expect_equal(iso3c_of('South Sudan'), 'SSD')
    expect_equal(iso3c_of('S\u00E3o Tom\u00E9 and Pr\u00EDncipe'), 'STP')
    expect_equal(iso3c_of('Suriname'), 'SUR')
    expect_equal(iso3c_of('Slovakia'), 'SVK')
    expect_equal(iso3c_of('Slovenia'), 'SVN')
    expect_equal(iso3c_of('Sweden'), 'SWE')
    expect_equal(iso3c_of('Swaziland'), 'SWZ')
    expect_equal(iso3c_of('Sint Maarten'), 'SXM')
    expect_equal(iso3c_of('Seychelles'), 'SYC')
    expect_equal(iso3c_of('Syria'), 'SYR')
    expect_equal(iso3c_of('Turks and Caicos Islands'), 'TCA')
    expect_equal(iso3c_of('Chad'), 'TCD')
    expect_equal(iso3c_of('Togo'), 'TGO')
    expect_equal(iso3c_of('Thailand'), 'THA')
    expect_equal(iso3c_of('Tajikistan'), 'TJK')
    expect_equal(iso3c_of('Tokelau'), 'TKL')
    expect_equal(iso3c_of('Turkmenistan'), 'TKM')
    expect_equal(iso3c_of('East Timor'), 'TLS')
    expect_equal(iso3c_of('Tonga'), 'TON')
    expect_equal(iso3c_of('Trinidad and Tobago'), 'TTO')
    expect_equal(iso3c_of('Tunisia'), 'TUN')
    expect_equal(iso3c_of('Turkey'), 'TUR')
    expect_equal(iso3c_of('Tuvalu'), 'TUV')
    expect_equal(iso3c_of('Taiwan'), 'TWN')
    expect_equal(iso3c_of('Tanzania'), 'TZA')
    expect_equal(iso3c_of('Uganda'), 'UGA')
    expect_equal(iso3c_of('Ukraine'), 'UKR')
    expect_equal(iso3c_of('United States Minor Outlying Islands'), 'UMI')
    expect_equal(iso3c_of('Uruguay'), 'URY')
    expect_equal(iso3c_of('United States'), 'USA')
    expect_equal(iso3c_of('Uzbekistan'), 'UZB')
    expect_equal(iso3c_of('Vatican City'), 'VAT')
    expect_equal(iso3c_of('Saint Vincent and the Grenadines'), 'VCT')
    expect_equal(iso3c_of('Venezuela'), 'VEN')
    expect_equal(iso3c_of('British Virgin Islands'), 'VGB')
    expect_equal(iso3c_of('United States Virgin Islands'), 'VIR')
    expect_equal(iso3c_of('Viet Nam'), 'VNM')
    expect_equal(iso3c_of('Vanuatu'), 'VUT')
    expect_equal(iso3c_of('Wallis and Futuna'), 'WLF')
    expect_equal(iso3c_of('Samoa'), 'WSM')
    expect_equal(iso3c_of('Yemen'), 'YEM')
    expect_equal(iso3c_of('South Africa'), 'ZAF')
    expect_equal(iso3c_of('Zambia'), 'ZMB')
    expect_equal(iso3c_of('Zimbabwe'), 'ZWE')
})

context('nomatch argument to fill-in non-matching code')

origin <- c('ALG', 'AUH', 'BAD')
test_that('nomatch argument works correctly', {
    expect_equal(countrycode(origin, 'cowc', 'iso3c', warn = FALSE), c('DZA', NA, NA))
    expect_equal(countrycode(origin, 'cowc', 'iso3c', warn = FALSE, nomatch = 'TEST'), c('DZA', 'TEST', 'TEST'))
    expect_equal(countrycode(origin, 'cowc', 'iso3c', warn = FALSE, nomatch = NULL), c('DZA', 'AUH', 'BAD'))
    expect_warning(countrycode(origin, 'cowc', 'iso3n', warn = FALSE, nomatch = NULL))
    expect_error(countrycode(origin, 'cowc', 'iso3c', warn = FALSE, nomatch = c('a', 'b')))
})

test_that('nomatch: numeric and character output types',{
    # numeric are coerced to character. is this desirable?
    expect_equal(countrycode('XXX', 'country.name', 'cowc', nomatch = 0), '0')
    expect_equal(countrycode('XXX', 'country.name', 'cown', nomatch = 0), 0)
    expect_warning(countrycode('XXX', 'country.name', 'cown', nomatch = 'Bad'))
})

test_that('nomatch argument works correctly when sourcevar is a factor', {
    # nomatch vector of length 1 that is the same class as the destination code
    # vector should replace all non-match elements with the nomatch value
    expect_equal(countrycode(factor('XXX'), 'iso3c', 'iso2c', nomatch = c('YYY')), 'YYY')
    expect_equal(countrycode(factor(c('XXX', 'USA', 'YYY')), 'iso3c', 'iso2c', nomatch = c('YY')), c('YY', 'US', 'YY'))

    # nomatch NULL should replace unmatched elements with the value in the
    # original sourcevar (if it's the same class as the destination code vector)
    expect_equal(countrycode(factor('XXX'), 'iso3c', 'iso2c', nomatch = NULL), 'XXX')
    expect_equal(countrycode(factor(c('XXX', 'USA', 'YYY')), 'iso3c', 'iso2c', nomatch = NULL), c('XXX', 'US', 'YYY'))

    # nomatch NA should replace unmatched elements with NA
    expect_equal(countrycode(factor('XXX'), 'iso3c', 'iso2c', nomatch = NA, warn = FALSE), NA_character_)
    expect_equal(countrycode(factor(c('XXX', 'USA', 'YYY')), 'iso3c', 'iso2c', nomatch = NA, warn = FALSE), c(NA, 'US', NA))

    # nomatch factor vector (undecided behavior; currently skipped/ignored)
    # expect_equal(countrycode(factor('XXX'), 'iso3c', 'iso2c', nomatch = factor('YY')), factor('YY'))
})

context('Destination-only codes')

test_that('Destination-only codes raise errors when used as origin', {
    f <- function(code) countrycode('x', origin = code, destination = 'iso3c')
    expect_error(f('currency'))
    expect_error(f('iso4217c'))
    expect_error(f('iso4217n'))
    expect_error(f('ar5'))
    expect_error(f('continent'))
    expect_error(f('cow.name'))
    expect_error(f('eu28'))
    expect_error(f('iso.name.en'))
    expect_error(f('cow.name'))
    expect_error(f('un.region.name'))
    expect_error(f('cldr.name.en'))
})

context('Special cases of regex')

iso3c_of <- function(name) countrycode(name, 'country.name', 'iso3c', warn = TRUE)
no_warn_iso3c_of <- function(name) countrycode(name, 'country.name', 'iso3c', warn = FALSE)
cowc_of <- function(name) countrycode(name, 'country.name', 'cowc', warn = TRUE)
no_warn_cowc_of <- function(name) countrycode(name, 'country.name', 'cowc', warn = FALSE)


test_that('names that should return NA', {
    expect_equal(no_warn_iso3c_of('ROC'), NA_character_)   # Could be Taiwan or Congo
    expect_equal(no_warn_iso3c_of('united arab republic'), NA_character_) # Doesn't have in iso3c
    expect_equal(no_warn_iso3c_of('Southern Africa'), NA_character_)
    expect_equal(no_warn_cowc_of('democratic republic of yemen'), NA_character_)
})


test_that("Guyana", {
    expect_equal(no_warn_iso3c_of("Guiana"), NA_character_) # Guiana is ambiguous in English
})


test_that('accented characters are properly matched', {
    expect_equal(iso3c_of('\u00C5land Islands'), 'ALA')
    expect_equal(iso3c_of('Saint Barth\u00E9lemy'), 'BLM')
    expect_equal(iso3c_of('C\u00F4te d\'Ivoire'), 'CIV')
    expect_equal(iso3c_of('Cura\u00E7ao'), 'CUW')
    expect_equal(iso3c_of('R\u00E9union'), 'REU')
    expect_equal(iso3c_of('S\u00E3o Tom\u00E9 and Pr\u00EDncipe'), 'STP')
})


test_that('some official country names are properly matched', {
    expect_equal(iso3c_of('democratic people\'s republic of korea'), 'PRK')
    expect_equal(iso3c_of('republic of guinea'), 'GIN')
    expect_equal(iso3c_of('hellenic republic'), 'GRC')
    expect_equal(iso3c_of('united mexican states'), 'MEX')
    expect_equal(iso3c_of('republic of the union of myanmar'), 'MMR')
    expect_equal(iso3c_of('independent state of samoa'), 'WSM')
    expect_equal(iso3c_of('republic of south sudan'), 'SSD')
    expect_equal(iso3c_of('swiss confederation'), 'CHE')
})


test_that('some unofficial country names are properly matched', {
    expect_equal(iso3c_of('dprk'), 'PRK')
    expect_equal(iso3c_of('byelorussia'), 'BLR')
    expect_equal(iso3c_of('british honduras'), 'BLZ')
    expect_equal(iso3c_of('bechuanaland'), 'BWA')
    expect_equal(iso3c_of('nyasaland'), 'MWI')
    expect_equal(iso3c_of('british east africa'), 'KEN')
    expect_equal(iso3c_of('east africa protectorate'), 'KEN')
    expect_equal(iso3c_of('east pakistan'), 'BGD')
    expect_equal(iso3c_of('chinese taipei'), 'TWN')
    expect_equal(iso3c_of('taipei'), 'TWN')
})


test_that('former Soviet republics are properly matched', {
    expect_equal(iso3c_of('russian soviet federative socialist republic'), 'RUS')
    expect_equal(iso3c_of('ukrainian soviet socialist republic'), 'UKR')
    expect_equal(iso3c_of('uzbek soviet socialist republic'), 'UZB')
    expect_equal(iso3c_of('kazakh soviet socialist republic'), 'KAZ')
    expect_equal(iso3c_of('byelorussian soviet socialist republic'), 'BLR')
    expect_equal(iso3c_of('azerbaijan soviet socialist republic'), 'AZE')
    expect_equal(iso3c_of('georgian soviet socialist republic'), 'GEO')
    expect_equal(iso3c_of('tajik soviet socialist republic'), 'TJK')
    expect_equal(iso3c_of('moldovian soviet socialist republic'), 'MDA')
    expect_equal(iso3c_of('kirghiz soviet socialist republic'), 'KGZ')
    expect_equal(iso3c_of('lithuanian soviet socialist republic'), 'LTU')
    expect_equal(iso3c_of('turkmen soviet socialist republic'), 'TKM')
    expect_equal(iso3c_of('armenian soviet socialist republic'), 'ARM')
    expect_equal(iso3c_of('latvian soviet socialist republic'), 'LVA')
    expect_equal(iso3c_of('estonian soviet socialist republic'), 'EST')
})


test_that('the Netherlands Antilles are all matched correctly', {
    # The codes for the Netherlands Antilles are deleted from ISO 3166-1 and
    # transitionally reserved for a period of 50 years:
    # https://www.iso.org/news/2010/12/Ref1383.html
    expect_equal(no_warn_iso3c_of('netherlands antilles'), NA_character_)                   # A former country
    expect_equal(no_warn_iso3c_of('dutch antilles'), NA_character_)                         # A former country
    expect_equal(no_warn_iso3c_of('dutch caribbean'), NA_character_)                        # The meaning of this unit is ambiguous
    expect_equal(iso3c_of('aruba'), 'ABW')                                                  # A country of the Netherlands
    expect_equal(iso3c_of('curaçao'), 'CUW')                                                # A country of the Netherlands
    expect_equal(iso3c_of('sint maarten'), 'SXM')                                           # A country of the Netherlands
    expect_equal(iso3c_of('collectivity of saint martin'), 'MAF')                           # A French overseas collectivity
    expect_equal(iso3c_of('saint martin (french part)'), 'MAF')                             # A French overseas collectivity
    expect_equal(no_warn_iso3c_of('saint martin'), NA_character_)                           # The meaning of this unit is ambiguous
    expect_equal(no_warn_iso3c_of('st. martin'), NA_character_)                             # The meaning of this unit is ambiguous
    expect_equal(no_warn_iso3c_of('saint-martin'), NA_character_)                           # An island, not a political entity
    expect_equal(no_warn_iso3c_of('St-Martin / Sint Maarten'), NA_character_)               # An island, not a political entity
    expect_equal(no_warn_iso3c_of('St-Martin / St-Maarten'), NA_character_)                 # An island, not a political entity
    expect_equal(no_warn_iso3c_of('St. Martin and St. Maarten'), NA_character_)             # An island, not a political entity
    expect_equal(no_warn_iso3c_of('St Maarten – St Martin'), NA_character_)                 # An island, not a political entity
    expect_equal(iso3c_of('bonaire, saba, and sint eustatius'), 'BES')                      # Municipalities of the Netherlands
    expect_equal(iso3c_of('bes islands'), 'BES')                                            # Municipalities of the Netherlands
    expect_equal(iso3c_of('caribbean netherlands'), 'BES')                                  # Municipalities of the Netherlands
    expect_equal(no_warn_iso3c_of('greater antilles'), NA_character_)                       # Not a political entity
    expect_equal(no_warn_iso3c_of('lesser antilles'), NA_character_)                        # Not a political entity
    expect_equal(no_warn_iso3c_of('abc islands'), NA_character_)                            # Not a political entity
    expect_equal(no_warn_iso3c_of('leeward islands'), NA_character_)                        # Not a political entity
    expect_equal(no_warn_iso3c_of('leeward antilles'), NA_character_)                       # Not a political entity
    expect_equal(no_warn_iso3c_of('aruba, bonaire, and curaçao'), NA_character_)            # Not a political entity
    expect_equal(no_warn_iso3c_of('sss islands'), NA_character_)                            # Not a political entity
    expect_equal(no_warn_iso3c_of('windward islands'), NA_character_)                       # Not a political entity
    expect_equal(no_warn_iso3c_of('sint maarten, saba, and sint eustatius'), NA_character_) # Not a political entity
})


test_that('some old and colonial names are matched', {
    expect_equal(iso3c_of('gold coast'), 'GHA')
    expect_equal(iso3c_of('upper volta'), 'BFA')
    expect_equal(iso3c_of('portuguese guinea'), 'GNB')
    expect_equal(iso3c_of('basutoland'), 'LSO')
    expect_equal(iso3c_of('northern rhodesia'), 'ZMB')
    expect_equal(iso3c_of('southern rhodesia'), 'ZWE')
    expect_equal(iso3c_of('rhodesia'), 'ZWE')
    expect_equal(iso3c_of('the argentine'), 'ARG')
    expect_equal(iso3c_of('dutch guiana'), 'SUR')
    expect_equal(iso3c_of('bohemia'), 'CZE')
    expect_equal(iso3c_of('czechia'), 'CZE')
    expect_equal(iso3c_of('french republic'), 'FRA')
    expect_equal(iso3c_of('gaul'), 'FRA')
    expect_equal(iso3c_of('hellas'), 'GRC')
    expect_equal(iso3c_of('bessarabia'), 'MDA')
    expect_equal(iso3c_of('bassarabia'), 'MDA')
    expect_equal(iso3c_of('rumania'), 'ROU')
    expect_equal(iso3c_of('roumania'), 'ROU')
    expect_equal(iso3c_of('mesopotamia'), 'IRQ')
    expect_equal(iso3c_of('trucial states'), 'OMN')
    expect_equal(iso3c_of('formosa'), 'TWN')
    expect_equal(iso3c_of('new hebrides'), 'VUT')
})


test_that('Micronesia is not Federated States of Micronesia', {
    # bare ambiguous label → NA in all language origins, and warn is emitted
    expect_warning(iso3c_of('Micronesia'), regexp = 'not matched')
    expect_equal(no_warn_iso3c_of('Micronesia'), NA_character_)
    expect_equal(countrycode('Mikronesien', 'country.name.de', 'iso3c', warn = FALSE), NA_character_)
    expect_equal(countrycode('Micron\u00e9sie', 'country.name.fr', 'iso3c', warn = FALSE), NA_character_)
    expect_equal(countrycode('Micronesia', 'country.name.it', 'iso3c', warn = FALSE), NA_character_)
    expect_equal(countrycode('Micronesia', 'country.name.es', 'iso3c', warn = FALSE), NA_character_)
    # unambiguous full English names → FSM
    expect_equal(iso3c_of('Federated States of Micronesia'), 'FSM')
    expect_equal(iso3c_of('Micronesia, Federated States of'), 'FSM')
    expect_equal(iso3c_of('Micronesia (Federated States of)'), 'FSM')
    # FS abbreviation forms (EN origin) → FSM
    expect_equal(iso3c_of('FS Micronesia'), 'FSM')
    expect_equal(iso3c_of('F.S. Micronesia'), 'FSM')
    expect_equal(iso3c_of('F S Micronesia'), 'FSM')
    # German: qualified forms → FSM, FS abbreviation → FSM
    expect_equal(countrycode('F\u00f6derierte Staaten von Mikronesien', 'country.name.de', 'iso3c'), 'FSM')
    expect_equal(countrycode('Mikronesien (F\u00f6derierte Staaten von)', 'country.name.de', 'iso3c'), 'FSM')
    expect_equal(countrycode('FS Mikronesien', 'country.name.de', 'iso3c'), 'FSM')
    expect_equal(countrycode('F.S. Mikronesien', 'country.name.de', 'iso3c'), 'FSM')
    # French: qualified forms → FSM, FS abbreviation → FSM
    expect_equal(countrycode('Micron\u00e9sie (\u00c9tats f\u00e9d\u00e9r\u00e9s de)', 'country.name.fr', 'iso3c'), 'FSM')
    expect_equal(countrycode('\u00c9tats f\u00e9d\u00e9r\u00e9s de Micron\u00e9sie', 'country.name.fr', 'iso3c'), 'FSM')
    expect_equal(countrycode('FS Micron\u00e9sie', 'country.name.fr', 'iso3c'), 'FSM')
    # Italian: qualified forms → FSM, FS abbreviation → FSM
    expect_equal(countrycode('Stati Federati di Micronesia', 'country.name.it', 'iso3c'), 'FSM')
    expect_equal(countrycode('Micronesia (Stati Federati di)', 'country.name.it', 'iso3c'), 'FSM')
    expect_equal(countrycode('FS Micronesia', 'country.name.it', 'iso3c'), 'FSM')
    # Spanish: qualified forms → FSM, FS abbreviation → FSM
    expect_equal(countrycode('Estados Federados de Micronesia', 'country.name.es', 'iso3c'), 'FSM')
    expect_equal(countrycode('Micronesia (Estados Federados de)', 'country.name.es', 'iso3c'), 'FSM')
    expect_equal(countrycode('FS Micronesia', 'country.name.es', 'iso3c'), 'FSM')
})


test_that('Northern Ireland is not Ireland (Issue #313)', {
    # Republic of Ireland
    expect_equal(iso3c_of('Ireland'), 'IRL')

    # Abbreviated and reordered Northern Ireland forms -> United Kingdom
    expect_equal(iso3c_of('Northern Ireland'), 'GBR')
    expect_equal(iso3c_of('North Ireland'), 'GBR')
    expect_equal(iso3c_of('N Ireland'), 'GBR')
    expect_equal(iso3c_of('N. Ireland'), 'GBR')
    expect_equal(iso3c_of('Ireland (Northern)'), 'GBR')
    expect_equal(iso3c_of('Ireland (North)'), 'GBR')
    expect_equal(iso3c_of('Ireland (N)'), 'GBR')
    expect_equal(iso3c_of('Ireland (N.)'), 'GBR')
    expect_equal(iso3c_of('Ireland, Northern'), 'GBR')
    expect_equal(iso3c_of('Ireland, North'), 'GBR')
    expect_equal(iso3c_of('Ireland, N.'), 'GBR')
    expect_equal(iso3c_of('Ireland, N'), 'GBR')
    expect_equal(iso3c_of('in the north of Ireland'), 'GBR')
})


test_that('East and West Germany are disambiguated', {
    # Basic Germany forms map to modern Germany / FRG
    expect_equal(iso3c_of('Germany'), 'DEU')
    expect_equal(cowc_of('Germany'), 'GMY')
    expect_equal(iso3c_of('Federal Republic of Germany'), 'DEU')
    expect_equal(cowc_of('Federal Republic of Germany'), 'GMY')

    # Historical East Germany (GDR) is identified by explicit east + germany forms
    expect_equal(cowc_of('East Germany'), 'GDR')
    expect_equal(cowc_of('Germany East'), 'GDR')

    # West Germany maps to Germany / FRG depending on destination code
    expect_equal(iso3c_of('West Germany'), 'DEU')
    expect_equal(iso3c_of('Germany West'), 'DEU')
    expect_equal(cowc_of('West Germany'), 'GMY')
    expect_equal(cowc_of('Germany West'), 'GMY')

    # Word boundaries avoid treating regional labels as the former GDR
    expect_equal(iso3c_of('Eastern Germany'), 'DEU')
    expect_equal(cowc_of('Eastern Germany'), 'GMY')
})


test_that('leading and trailing whitespace does not interfere', {
    expect_equal(cowc_of(' Republic of Vietnam'), 'RVN')
    expect_equal(cowc_of('\tUnited States'), 'USA')
   expect_equal(cowc_of('Republic of Vietnam '), 'RVN')
    expect_equal(cowc_of('United States\t'), 'USA')
})

context('Known country name variations')

library(utf8)

source('data-known-name-variations.R')

test_that('correct matches are returned for known country name variations', {
  name_of <- function(known_variations) {
      countrycode(known_variations, 'country.name', 'country.name', warn=FALSE)
  }
  for (i in seq_along(variations)) {
      for (j in seq_along(variations[[i]])) {
          expect_identical(utf8_format(names(variations)[i]), 
                           name_of(variations[[i]][j]))
      }
  }
})

question <- c("Aroba", "Canuda")
answer <- c("Aruba", "Canada")

test_that("no attributes", {

  dict <- data.frame(
    a = c("ar.ba", "can.da"),
    b = c("Aruba", "Canada"))

  expect_warning(expect_equal(
    c(NA_character_, NA_character_),
    countrycode(question, "a", "b", custom_dict = dict, origin_regex = FALSE)))

  expect_warning(expect_equal(
    c(NA_character_, NA_character_),
    countrycode(question, "a", "b", custom_dict = dict, origin_regex = NULL)))

  expect_equal(
    answer,
    countrycode(question, "a", "b", custom_dict = dict, origin_regex = TRUE))
})

test_that("origin_regex attribute", {
  dict <- data.frame(
    a = c("ar.ba", "can.da"),
    b = c("Aruba", "Canada"))
  attr(dict, "origin_regex") <- "a"

  expect_equal(
    answer,
    countrycode(question, "a", "b", custom_dict = dict, origin_regex = NULL))

  expect_equal(
    answer,
    countrycode(question, "a", "b", custom_dict = dict))
})

test_that("origin_valid attribute", {
  dict <- data.frame(
    a = c("ar.ba", "can.da"),
    b = c("Aruba", "Canada"))
  attr(dict, "origin_valid") <- "a"
  attr(dict, "origin_regex") <- "a"
  expect_equal(
    answer,
    countrycode(question, "a", "b", custom_dict = dict))
  expect_error(countrycode(question, "b", "a", custom_dict = dict),
               regexp = "origin")
})

context('Basic conversions')

test_that('valid iso3c to country.name works', {
    name_of <- function(iso3c_code) countrycode(iso3c_code, 'iso3c', 'country.name')
    expect_equal(name_of('CAN'), 'Canada')
    expect_equal(name_of(c('USA', 'CAN')), c('United States', 'Canada'))
})


test_that("Issue #252: new code polity5", {
    expect_equal(countrycode("United States", "country.name", "p5c"), "USA")
    expect_equal(countrycode("United States", "country.name", "p5n"), 2)
})

test_that('invalid iso3c to country.name returns NA', {
    name_of <- function(iso3c_code) countrycode(iso3c_code, 'iso3c', 'country.name', warn = FALSE)
    expect_equal(name_of('BAD'), NA_character_)
    expect_equal(name_of(c('BAD', 'BLA', 'CAN')), c(NA_character_, NA_character_, 'Canada'))
})

test_that('warn=TRUE gives warnings, but does not break conversion', {
    iso2c_of <- function(cowc_code) countrycode(cowc_code, 'cowc', 'iso2c', warn=TRUE)
    expect_warning(val <- iso2c_of('BLA'), 'not matched')
    expect_equal(val, NA_character_)
    expect_warning(val <- iso2c_of(c('ALG', 'USA')), NA)
    expect_equal(val, c('DZ','US'))
    expect_warning(val <- iso2c_of(c('BLA', 'USA')), 'not matched')
    expect_equal(val, c(NA_character_,'US'))
})

test_that('warn=FALSE does not give warnings', {
    iso2c_of <- function(cowc_code) countrycode(cowc_code, 'cowc', 'iso2c', warn=FALSE)
    expect_warning(iso2c_of('BLA'), NA)
    expect_warning(iso2c_of(c('BLA', 'USA')), NA)
})


test_that("Issue #272", {
    expect_error(countrycode("2", "cown", "country.name"), regexp = "must be numeric")
})

test_that("vector of destination codes", {
    expect_equal(countrycode("Serbia", "country.name", "iso3c"), "SRB")
    expect_warning(expect_equal(countrycode("Serbia", "country.name", "cowc"), NA_character_))
    expect_warning(expect_equal(countrycode("Serbia", "country.name", c("cowc", "iso3c")), "SRB"))
})

cs <- countrycode::codelist
pan <- countrycode::codelist_panel

dest <- c('year', 'ar5', 'continent', 'currency', 'eu28', 'eurocontrol_pru',
          'eurocontrol_statfor', 'icao', 'icao.region', 'iso4217c',
          'iso4217n','region', 'region23', 'un.region.name', 'un.region.code',
          'un.regionsub.name', 'un.regionsub.code', 'telephone',
          'un.regionintermediate.name', 'un.regionintermediate.code', 'unhcr.region')

##############
#  codelist  #
##############

context('codelist')

# class
test_that('codelist is a data.frame', {
    expect_true(inherits(cs, 'data.frame'))
})

# dimensions
test_that('codelist has (roughly) correct dimensions', {
    expect_gt(nrow(cs), 250)
    expect_lt(nrow(cs), 300)
    expect_gt(ncol(cs), 600)
    expect_lt(ncol(cs), 650)
})

# columns
cols <- c('country.name.en.regex', 'country.name.en', 'iso3c', 'cowc', 'p4c', 'vdem')
for (i in cols) {
    test_that(paste('codelist includes', i), {
        expect_true(i %in% colnames(cs))
    })
}

# missing
test_that('codelist missing values', {
    expect_false(any(is.na(cs$country.name.en.regex)))
    expect_false(any(is.na(cs$country.name.en)))
    expect_lt(mean(is.na(cs$iso3c)), .2)
    expect_lt(mean(is.na(cs$cowc)), .3)
    for (i in colnames(cs)) {
        expect_false(all(is.na(cs[[i]])))
    }
})

cols <- setdiff(colnames(cs), c('dhs', 'eu28', 'un.regionintermediate.name',
                                'un.regionintermediate.code'))
for (i in cols) {
    msg <- paste(i, 'has less than 50% missing observations')
    test_that(msg, {
        expect_lt(mean(is.na(cs[[i]])), .5)
    })
}


# duplicate
for (i in colnames(cs)) {
    if (!i %in% dest) {
        test_that(paste0('codelist$', i, ' has no duplicates'), {
            expect_equal(anyDuplicated(na.omit(cs[[i]])), 0)
         })
    }
}

# literal NAs
test_that('codelist has no literal "NA"s (except Namibia)', {
  cs_no_namibia <- subset(cs, country.name.en != 'Namibia')
  for (i in colnames(cs_no_namibia)) {
      expect_false(any(cs_no_namibia[[!!i]] == 'NA', na.rm = TRUE))
  }
})

###########
#  panel  #
###########

context('codelist_panel')

# class
test_that('codelist_panel is a data.frame', {
    expect_true(inherits(pan, 'data.frame'))
})

# dimensions
test_that('codelist_panel has (roughly) correct dimensions', {
    expect_gt(nrow(pan), 25000)
    expect_lt(nrow(pan), 30000)
    expect_gt(ncol(pan), 40)
    expect_lt(ncol(pan), 60)
})

# columns
cols <- c('country.name.en.regex', 'country.name.en', 'year', 'iso3c', 'cowc', 'p4c', 'vdem')
for (i in cols) {
    test_that(paste('codelist_panel includes', i), {
        expect_true(i %in% colnames(pan))
    })
}

# missing
test_that('codelist_panel missing values', {
    expect_false(any(is.na(pan$country.name.en.regex)))
    expect_false(any(is.na(pan$country.name.en)))
    expect_false(any(is.na(pan$year)))
    expect_lt(mean(is.na(pan$iso3c)), .1)
    expect_lt(mean(is.na(pan$cowc)), .45)
    for (i in colnames(pan)) {
        expect_false(all(is.na(pan[[i]])))
    }
})

cols <- setdiff(colnames(pan), c('dhs', 'eu28', 'un.regionintermediate.name',
                                 'un.regionintermediate.code'))
for (i in cols) {
    msg <- paste(i, 'has less than 50% missing observations')
    test_that(msg, {
        expect_lt(mean(is.na(pan[[i]])), .5)
    })
}

# duplicate
for (i in colnames(pan)) {
    if (!i %in% dest) {
        test_that(paste0('codelist_panel$', i, ' has no duplicates'), {
            idx <- pan[, c(i, 'year')]
            idx <- na.omit(idx)
            idx <- paste(idx[[1]], idx[[2]])
            expect_equal(anyDuplicated(idx), 0)
         })
    }
}

# literal NAs
test_that('codelist_panel has no literal "NA"s (except Namibia)', {
  pan_no_namibia <- subset(pan, country.name.en != 'Namibia')
  for (i in colnames(pan_no_namibia)) {
    expect_false(any(pan_no_namibia[[!!i]] == 'NA', na.rm = TRUE))
  }
})

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/cldr_examples.R
\docType{data}
\name{cldr_examples}
\alias{cldr_examples}
\title{List of CLDR country name codes and associated examples}
\format{
data frame
}
\usage{
cldr_examples
}
\description{
\itemize{
\item Code: CLDR code
\item Example: French Southern Territories in different languages
}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/countryname.R
\name{countryname}
\alias{countryname}
\title{Convert country names in any language to another name or code}
\usage{
countryname(
  sourcevar,
  destination = "country.name.en",
  nomatch = NA,
  warn = TRUE
)
}
\arguments{
\item{sourcevar}{Vector which contains the codes or country names to be
converted (character or factor)}

\item{destination}{Coding scheme of destination (string such as "iso3c"
enclosed in quotes ""): type \code{?codelist} for a list of
available codes.}

\item{nomatch}{When countrycode fails to find a match for the code of
origin, it fills-in the destination vector with \code{nomatch}. The default
behavior is to fill non-matching codes with \code{NA}. If \code{nomatch = NULL},
countrycode tries to use the origin vector to fill-in missing values in the
destination vector. \code{nomatch} must be either \code{NULL}, of length 1, or of the same
length as \code{sourcevar}.}

\item{warn}{Prints unique elements from sourcevar for which no match was found}
}
\description{
Converts long country names in any language to one of many different country
code schemes or country names. \code{countryname} does 2 passes on the data.
First, it tries to detect variations of country names in many languages
extracted from the Unicode Common Locale Data Repository. Second, it applies
\code{countrycode}'s English regexes to try to match the remaining cases. Because
it does two passes, \code{countryname} can sometimes produce ambiguous results,
e.g., Saint Martin vs. Saint Martin (French Part). Users who need a "safer"
option can use: \code{countrycode(x, "country.name", "country.name")} Note that
the function works with non-ASCII characters. Please see the Github page for
examples.
}
\examples{
\dontrun{
x <- c('Afaganisitani', 'Barbadas', 'Sverige', 'UK')
countryname(x)
countryname(x, destination = 'iso3c')
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/countryname_dict.R
\docType{data}
\name{countryname_dict}
\alias{countryname_dict}
\title{A dataframe of alternative country names in many languages. Used internally by
the \code{countryname} function.}
\format{
dataframe
}
\description{
A dataframe of alternative country names in many languages. Used internally by
the \code{countryname} function.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/codelist_panel.R
\docType{data}
\name{codelist_panel}
\alias{codelist_panel}
\title{Country Code Translation Data Frame (Country-Year Panel)}
\format{
data frame with codes as columns
}
\usage{
codelist_panel
}
\description{
A panel of country-year observations with various codes
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/countrycode.R
\name{countrycode}
\alias{countrycode}
\title{Convert Country Codes}
\usage{
countrycode(
  sourcevar,
  origin,
  destination,
  warn = TRUE,
  nomatch = NA,
  custom_dict = NULL,
  custom_match = NULL,
  origin_regex = NULL
)
}
\arguments{
\item{sourcevar}{Vector which contains the codes or country names to be
converted (character or factor)}

\item{origin}{A string which identifies the coding scheme of origin (e.g., \code{"iso3c"}). See
\code{\link{codelist}} for a list of available codes.}

\item{destination}{A string or vector of strings which identify the coding
scheme of destination (e.g., \code{"iso3c"} or \code{c("cowc", "iso3c")}). See
\code{\link{codelist}} for a list of available codes. When users supply a
vector of destination codes, they are used sequentially to fill in
missing values not covered by the previous destination code in the
vector.}

\item{warn}{Prints unique elements from sourcevar for which no match was found}

\item{nomatch}{When countrycode fails to find a match for the code of
origin, it fills-in the destination vector with \code{nomatch}. The default
behavior is to fill non-matching codes with \code{NA}. If \code{nomatch = NULL},
countrycode tries to use the origin vector to fill-in missing values in the
destination vector. \code{nomatch} must be either \code{NULL}, of length 1, or of the same
length as \code{sourcevar}.}

\item{custom_dict}{A data frame which supplies a new dictionary to
replace the built-in country code dictionary. Each column
contains a different code and must include no duplicates. The
data frame format should resemble \code{\link{codelist}}. Users
can pre-assign attributes to this custom dictionary to affect
behavior (see Examples section):
\itemize{
\item "origin.regex" attribute: a character vector with the names
of columns containing regular expressions.
\item "origin.valid" attribute: a character vector with the names
of columns that are accepted as valid origin codes.
}}

\item{custom_match}{A named vector which supplies custom origin and
destination matches that will supercede any matching default result. The name
of each element will be used as the origin code, and the value of each
element will be used as the destination code. Values supplied via
\code{custom_match} supersede ambiguous or duplicate matches and will not
trigger the corresponding ambiguity/duplicate-match warnings for those
values.}

\item{origin_regex}{NULL or Logical: When using a custom
dictionary, if TRUE then the origin codes will be matched as
regex, if FALSE they will be matched exactly. When NULL,
\code{countrycode} will behave as TRUE if the origin name is in the
\code{custom_dictionary}'s \code{origin_regex} attribute, and FALSE
otherwise. See examples section below.}
}
\description{
Converts long country names into one of many different coding schemes.
Translates from one scheme to another. Converts country name or coding
scheme to the official short English country name. Creates a new variable
with the name of the continent or region to which each country belongs.
}
\note{
For a complete description of available country codes and languages,
please see the documentation for the \code{\link{codelist}} conversion
dictionary.

Panel data (i.e., country-year) can pose particular problems when
converting codes. For instance, some countries like Vietnam or Serbia go
through political transitions that justify changing codes over time. This
can pose problems when using codes from organizations like CoW or Polity IV,
which produce codes in country-year format. Instead of converting codes
using \code{countrycode()}, we recommend that users use the
\code{\link{codelist_panel}} data.frame as a base into which they can
merge their other data. This data.frame includes most relevant code, and is
already "reconciled" to ensure that each political unit is only represented
by one row in any given year. From there, it is just a matter of using \code{\link[=merge]{merge()}}
to combine different datasets which use different codes.
}
\examples{
library(countrycode)

# ISO to Correlates of War
countrycode(c('USA', 'DZA'), origin = 'iso3c', destination = 'cown')

# English to ISO
countrycode('Albania', origin = 'country.name', destination = 'iso3c')

# German to French
countrycode('Albanien', origin = 'country.name.de', destination = 'iso.name.fr')

# Using custom_match to supercede default codes
countrycode(c('United States', 'Algeria'), 'country.name', 'iso3c')
countrycode(c('United States', 'Algeria'), 'country.name', 'iso3c',
            custom_match = c('Algeria' = 'ALG'))

x <- c("canada", "antarctica")
countryname(x)
countryname(x, destination = "cowc", warn = FALSE)
countryname(x, destination = "cowc", warn = FALSE, nomatch = x)

}
\keyword{countrycode}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/get_dictionary.R
\name{get_dictionary}
\alias{get_dictionary}
\title{Get Custom Dictionaries}
\usage{
get_dictionary(dictionary = NULL)
}
\arguments{
\item{dictionary}{A character string that specifies the dictionary to be
retrieved. It must be one of "global_burden_of_disease", "ch_cantons",
"us_states", "exiobase3", "gtap10". If NULL, the function will print the list
of available dictionaries. Default is NULL.}
}
\value{
If a valid dictionary is specified, the function will return that dictionary as a data.frame.
If an invalid dictionary or no dictionary is specified, the function will stop and throw an error message.
}
\description{
Download a custom dictionary to use in the \code{custom_dict} argument of \code{countrycode()}
}
\examples{
\dontrun{
cd <- get_dictionary("us_states")
countrycode::countrycode(c("MO", "MN"), origin = "state.abb", "state.name", custom_dict = cd)
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/codelist.R
\docType{data}
\name{codelist}
\alias{codelist}
\title{Country Code Translation Data Frame (Cross-Sectional)}
\format{
A data frame with codes as columns.
}
\description{
A data frame used internally by the \code{\link[=countrycode]{countrycode()}} function. \code{countrycode} can use any valid code as destination, but only some codes can be used as origin.
}
\details{
\subsection{Origin and Destination}{
\itemize{
\item \code{cctld}: IANA country code top-level domain
\item \code{country.name.en}: country name (English)
\item \code{country.name.de}: country name (German)
\item \code{country.name.fr}: country name (French)
\item \code{country.name.it}: country name (Italian)
\item \code{country.name.es}: country name (Spanish)
\item \code{cowc}: Correlates of War character
\item \code{cown}: Correlates of War numeric
\item \code{dhs}: Demographic and Health Surveys Program
\item \code{ecb}: European Central Bank
\item \code{eurostat}:  Eurostat
\item \code{fao}: Food and Agriculture Organization of the United Nations numerical code
\item \code{fips}: FIPS 10-4 (Federal Information Processing Standard)
\item \code{gaul}: Global Administrative Unit Layers
\item \code{genc2c}: GENC 2-letter code
\item \code{genc3c}: GENC 3-letter code
\item \code{genc3n}: GENC numeric code
\item \code{gwc}: Gleditsch & Ward character
\item \code{gwn}: Gleditsch & Ward numeric
\item \code{imf}: International Monetary Fund (Warning: The IMF generally uses ISO codes. These codes are WEO-related, but may be inconsistently used in the wild.)
\item \code{ioc}: International Olympic Committee
\item \code{iso2c}: ISO-2 character
\item \code{iso3c}: ISO-3 character
\item \code{iso3n}: ISO-3 numeric
\item \code{p5n}: Polity V numeric country code
\item \code{p5c}: Polity V character country code
\item \code{p4n}: Polity IV numeric country code
\item \code{p4c}: Polity IV character country code
\item \code{un}: United Nations M49 numeric codes
\item \code{unicode.symbol}: Region subtag (often displayed as emoji flag)
\item \code{unhcr}: United Nations High Commissioner for Refugees
\item \code{unpd}: United Nations Procurement Division
\item \code{vdem}: Varieties of Democracy (V-Dem version 8, April 2018)
\item \code{wb}: World Bank (very similar but not identical to iso3c)
\item \code{wvs}: World Values Survey numeric code
}
}

\subsection{Destination only}{
\itemize{
\item \verb{cldr.*}: 600+ country name variants from the UNICODE CLDR project (e.g., "cldr.short.en").
Inspect the \code{\link[=cldr_examples]{cldr_examples}} data.frame for a full list of
available country names and examples.
\item \code{ar5}: IPCC's regional mapping used both in the Fifth Assessment Report
(AR5) and for the Reference Concentration Pathways (RCP)
\item \code{continent}: Continent as defined in the World Bank Development Indicators
\item \code{cow.name}: Correlates of War country name
\item \code{currency}: ISO 4217 currency name
\item \code{eurocontrol_pru}:  European Organisation for the Safety of Air Navigation
\item \code{eurocontrol_statfor}:  European Organisation for the Safety of Air Navigation
\item \code{eu28}: Member states of the European Union (as of December 2015),
without special territories
\item \code{icao.region}: International Civil Aviation Organization region
\item \code{iso.name.en}: ISO English short name
\item \code{iso.name.fr}: ISO French short name
\item \code{iso4217c}: ISO 4217 currency alphabetic code
\item \code{iso4217n}: ISO 4217 currency numeric code
\item \code{p4.name}: Polity IV country name
\item \code{region}: 7 Regions as defined in the World Bank Development Indicators
\item \code{region23}: 23 Regions as used to be in the World Bank Development Indicators (legacy)
\item \code{telephone}: ITU-T E.164 country codes for telecommunication
\item \code{un.name.ar}: United Nations Arabic country name
\item \code{un.name.en}: United Nations English country name
\item \code{un.name.es}: United Nations Spanish country name
\item \code{un.name.fr}: United Nations French country name
\item \code{un.name.ru}: United Nations Russian country name
\item \code{un.name.zh}: United Nations Chinese country name
\item \code{un.region.name}: United Nations region name
\item \code{un.region.code}: United Nations region code
\item \code{un.regionintermediate.name}: United Nations intermediate region name
\item \code{un.regionintermediate.code}: United Nations intermediate region code
\item \code{un.regionsub.name}: United Nations sub-region name
\item \code{un.regionsub.code}: United Nations sub-region code
\item \code{unhcr.region}: United Nations High Commissioner for Refugees region name
\item \code{wvs.name}: World Values Survey numeric code country name
}
}
}
\note{
The Correlates of War (cow) and Polity 4 (p4) project produce codes in
country year format. Some countries go through political transitions that
justify changing codes over time. When building a purely cross-sectional
conversion dictionary, this forces us to make arbitrary choices with respect
to some entities (e.g., Western Germany, Vietnam, Serbia). \code{countrycode}
includes a reconciled dataset in panel format,
\code{\link[=codelist_panel]{codelist_panel}}. Instead of converting code, we recommend
that users dealing with panel data "left-merge" their data into this panel
dictionary.
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/guess_field.R
\name{guess_field}
\alias{guess_field}
\title{Guess the code/name of a vector}
\usage{
guess_field(codes, min_similarity = 80)
}
\arguments{
\item{codes}{a vector of country codes or country names}

\item{min_similarity}{the function returns all field names where over than
\code{min_similarity}\% of codes are shared between the supplied vector and the
\code{countrycode} dictionary.}
}
\description{
Users sometimes do not know what kind of code or field their data contain.
This function tries to guess by comparing the similarity between a
user-supplied vector and all the codes included in the \code{countrycode}
dictionary.
}
\examples{
# Guess ISO codes
guess_field(c('DZA', 'CAN', 'DEU'))

# Guess country names
guess_field(c('Guinea','Iran','Russia','North Korea',rep('Ivory Coast',50),'Scotland'))
}
